<?php

# set_include_path(get_include_path().":".HTML2PS_DIR.":");
$basepath = '/opt/monitor/op5/reports/gui';
chdir($basepath);

require_once '/opt/monitor/op5/auto-reports/lib_auto.php';
require_once '/opt/monitor/op5/auto-reports/lib_mail.php';
require_once 'lib_reports.php';
require_once 'lib_gui.php';

#global $map_type_field, $avail_setup_keys;



if($argc < 3)
{
	error_log(sprintf("usage: %s id recipient1,recipient2,...,recipientN filename", $argv[0]));
	exit;
}

$id = $argv[1];
$recipients = explode(',', $argv[2]);
$filename = $argv[3]; # could be empty string, handled below


global $dba;

$query = "SELECT * FROM avail_config WHERE id = $id";
$res = $dba->execute($query);

if(count($res) > 0)
{
	$row =& $res[0];

	# needed for monitor_auth
	$_SERVER['SERVER_NAME'] = 'op5monitor';
	$_SERVER['REMOTE_USER'] = $row['user'];
	$_SERVER['REQUEST_URI'] = '/monitor/op5/reports/gui/avail_result.php';

	$basepath = '/var/www/html/monitor/op5/reports/gui';
	$baseurl = "$basepath/avail_result.php";
	$output_filename = '/tmp/report.pdf';
	$report_name = $row['report_name'];
	if(empty($filename))
		$filename = str_replace(' ', '', $report_name);

	$config_keys = array
	(
		'rpttimeperiod' ,
		'report_period' ,
		'start_time' ,
		'end_time' ,
		'report_type' ,
		'initialassumedhoststate' ,
		'initialassumedservicestate' ,
		'assumeinitialstates' ,
		'scheduleddowntimeasuptime' ,
		'assumestatesduringnotrunning' ,
		'includesoftstates' ,
	    'keep_logs',
	    'keep_logs_maxrows'
	 ##'keep_logs_states_mask'
	);

	$report_inputs = array();
	foreach($config_keys as $key)
	{
		$report_inputs[$key] = $row[$key];
	}

	$report_inputs['new_avail_report_setup'] = 1;
	$report_inputs['generating_pdf'] = 1;
	$report_inputs['keep_logs_states'] = mask_to_state_masks($row['keep_logs_states_mask']);

	# fetch objects
	$query = "SELECT * FROM avail_config_objects WHERE avail_id = $id";
	$res = $dba->execute($query);

	if(count($res) > 0)
	{
		$obj_key = '';
		switch($report_inputs['report_type'])
		{
			case 'hosts': 		$obj_key = 'host_name'; break;
			case 'hostgroups': 	$obj_key = 'hostgroup'; break;
			case 'services': 	$obj_key = 'service_description'; break;
			default: 			$obj_key = 'servicegroup';
		}
		$report_inputs[$obj_key] = array();

		foreach($res as $row)
			$report_inputs[$obj_key][] = $row['name'];

		$output_filename = create_pdf($baseurl, $report_inputs, array('avail_result.php'));

		send_report($recipients, $output_filename, $filename);

		unlink($output_filename);
	}
}
else
{
	error_log(sprintf("%s: no availability report with id %d", $argv[0], $id));
}

?>
