<?php
// tmp
require_once('paths.inc.php');
global $op5common_path;
require_once($op5common_path."/lib/json_class.php");
require_once('template_class.php');
require_once('lib_reports.php');
require_once 'lib_pdf.php';
$report_class = new report_class();
require_once('lib_gui.php');
require_once 'default_settings.php';
require_once('auth.php');

$map_type_field = array(
	'hosts' => "host_name",
	'services' => "service_description",
	'hostgroups' => "hostgroup",
	'servicegroups' => "servicegroup"
);

$avail_setup_keys = array(
	'report_name',
	'info',
	'rpttimeperiod',
	'report_period',
	'start_time',
	'end_time',
	'report_type',
	'initialassumedhoststate',
	'initialassumedservicestate',
	'assumeinitialstates',
	'scheduleddowntimeasuptime',
	'assumestatesduringnotrunning',
	'includesoftstates',
	'use_average',
	'use_alias',
    'keep_logs',
	'keep_logs_maxrows',
    #'keep_logs_states',
);
global $default_initial_assumed_host_state, $default_initial_assumed_service_state;

$mon_auth = new monitor_auth_class(get_array_var($_SERVER, 'REMOTE_USER'));

$initial_assumed_host_states = array
(
   -1 => 'Current state',
   -2 => 'Unspecified',
   -3 => 'First Real State',
    0 => 'Host Up',
    1 => 'Host Down',
    2 => 'Host Unreachable',
);

$initial_assumed_service_states = array
(
   -1 => 'Current state',
   -2 => 'Unspecified',
   -3 => 'First Real State',
    0 => 'Service Ok',
    1 => 'Service Warning',
    2 => 'Service Critical',
    3 => 'Service Unknown',
);


// Collect input vars
$in_host 			= get_array_var($_REQUEST, array('host', 'host_name'), array());
$in_service 		= get_array_var($_REQUEST, array('service', 'service_description'), array());
if (isset($_REQUEST['show_log_entries'])) {
	$_REQUEST['report_period'] = 'last24hours';
	$_REQUEST['assumeinitialstates'] = 1;
	$assumeinitialstates = 1;
}
// =============== Handle saved reports =====================
$avail_options = false;

foreach ($avail_setup_keys as $k)	$avail_options[$k] = false;

// store all variables in array for later use
foreach ($_REQUEST as $key => $value) {
	if (in_array($key, $avail_setup_keys)) {
		if (get_array_var($_REQUEST, 'report_period') == 'custom' && ($key=='start_time' || $key=='end_time')) {
			$avail_options[$key] = strtotime($value);
		} else {
			$avail_options[$key] = $value;
		}
	} else if ($key == 'keep_logs_states') {
		$avail_options['keep_logs_states_mask'] = states_to_mask($_REQUEST[$key]);
	}
}

$obj_field = $avail_options['report_type'] !== false ? $map_type_field[$avail_options['report_type']] : false;
$obj_value = get_array_var($_REQUEST, $obj_field);
// obj_value is ALWAYS an array

$save_avail_settings 	= get_array_var($_REQUEST, 'save_avail_settings');
$avail_id 				= get_array_var($_REQUEST, 'avail_id');
$status_msg				= false;
$avail_info				= false;
$msg_type				= false;
if ($save_avail_settings) {
	$avail_id = edit_report_info($avail_id, $avail_options, $obj_value);
	$status_msg = $avail_id ? "Report was successfully saved" : "";
	$msg_type = $avail_id ? "ok" : "";
}

if (!empty($avail_id)) {
	$avail_info = get_report_info($avail_id);
}

if(is_string($in_host))
{
	// shorthand aliases - host=all is used for 'View avail for all hosts'
	if($in_host == 'all')
	{
		$in_host = $mon_auth->get_authorized_hosts();
	}
	elseif($in_host == 'null' && is_string($in_service) && $in_service == 'all') // Used for link 'View avail for all services'
	{
		$in_host = $mon_auth->get_authorized_hosts();
		$in_service = $mon_auth->get_authorized_services();
	}
	else // handle call from trends.cgi, which does not pass host parameter as array
	{
		if ($mon_auth->is_authorized_for_host($in_host))
			$in_host = array($in_host);
		else
			$in_host = array();
	}
}
else
{
	foreach ($in_host as $k => $host) {
		if (!$mon_auth->is_authorized_for_host($host))
			unset($in_host[$k]);
	}
}


# Service report in old system sends host and service as separate parameters.
# Anyone knows a nicer way to check this?
if(is_string($in_service) && strpos($in_service, ';') === false && count($in_host) == 1)
{
	$in_service = array(current($in_host).";$in_service");
}
foreach ($in_service as $k => $service) {
	if (!$mon_auth->is_authorized_for_service($service))
		unset($in_service[$k]);
}
$in_hostgroup 		= get_array_var($_REQUEST, 'hostgroup', array());


foreach ($in_hostgroup as $k => $hostgroup) {
	if (!$mon_auth->is_authorized_for_hostgroup($hostgroup))
		unset($in_hostgroup[$k]);
}
$in_servicegroup 	= get_array_var($_REQUEST, 'servicegroup', array());
foreach ($in_servicegroup as $k => $servicegroup) {
	if (!$mon_auth->is_authorized_for_servicegroup($servicegroup))
		unset($in_servicegroup[$k]);
}

$cgibin_path = '/monitor/cgi-bin/';

$report_type		= get_array_var($_REQUEST, 'report_type');
$in_csvoutput		= get_array_var($_REQUEST, 'csvoutput');

$start_time			= get_array_var($_REQUEST, 't1') ? get_array_var($_REQUEST, 't1') : get_array_var($_REQUEST, 'start_time');
$end_time			= get_array_var($_REQUEST, 't2') ? get_array_var($_REQUEST, 't2') : get_array_var($_REQUEST, 'end_time');
$report_period		= get_array_var($_REQUEST, 'timeperiod') ? get_array_var($_REQUEST, 'timeperiod') : get_array_var($_REQUEST, 'report_period');
$rpttimeperiod 		= get_array_var($_REQUEST, 'rpttimeperiod', '');

$start_date			= false;
$end_date			= false;
$hostgroup			= false;
$hostname			= false;
$servicegroup		= false;
$service			= false;
$sub_type			= false;
$time_parts 		= false;

// cgi compatibility variables
// Start dates
$syear 	= (int)get_array_var($_REQUEST, 'syear');
$smon 	= (int)get_array_var($_REQUEST, 'smon');
$sday 	= (int)get_array_var($_REQUEST, 'sday');
$shour 	= (int)get_array_var($_REQUEST, 'shour');
$smin 	= (int)get_array_var($_REQUEST, 'smin');
$ssec 	= (int)get_array_var($_REQUEST, 'ssec');
// end dates
$eyear 	= (int)get_array_var($_REQUEST, 'eyear');
$emon 	= (int)get_array_var($_REQUEST, 'emon');
$eday 	= (int)get_array_var($_REQUEST, 'eday');
$ehour 	= (int)get_array_var($_REQUEST, 'ehour');
$emin 	= (int)get_array_var($_REQUEST, 'emin');
$esec 	= (int)get_array_var($_REQUEST, 'esec');
$report_type = check_report_type($report_type, $in_host, $in_service, $servicegroup, $hostgroup);


$report_period_strings = array
(
	'today'       => 'Today',
	'last24hours' => 'Last 24 hours',
	'yesterday'   => 'Yesterday',
	'thisweek'    => 'This week',
	'last7days'   => 'Last 7 days',
	'lastweek'    => 'Last week',
	'thismonth'   => 'This month',
	'last31days'  => 'Last 31 days',
	'lastmonth'   => 'Last month',
	'thisyear'    => 'This year',
	'lastyear'    => 'Last year',
);

# these inputs are not provided when called from trends.cgi
if(!isset($_REQUEST['rpttimeperiod']))
	$_REQUEST['rpttimeperiod'] = '';

# default to "Current state" = -1 both in new and old avail
if(!isset($_REQUEST['initialassumedhoststate']))
	$_REQUEST['initialassumedhoststate'] = '-1';

if(!isset($_REQUEST['initialassumedservicestate']))
	$_REQUEST['initialassumedservicestate'] = '-1';

if (!isset($_REQUEST['keep_logs_states']))
	$_REQUEST['keep_logs_states'] = mask_to_state_masks(0xffffffff);

if (!isset($_REQUEST['keep_logs_maxrows']))
	$_REQUEST['keep_logs_maxrows'] = $default_keep_logs_maxrows;

$options = array(
	'rpttimeperiod' => 'report_timeperiod',
	'scheduleddowntimeasuptime' => 'scheduled_downtime_as_uptime',
	'assumestatesduringnotrunning' => 'assume_states_during_not_running',
	'includesoftstates' => 'include_soft_states',
	'assumeinitialstates' => 'assume_initial_states',
	'use_average' =>'use_average',
	'keep_logs' => 'keep_logs',
	'keep_logs_maxrows' => 'keep_logs_maxrows',
	'keep_logs_states' => 'keep_logs_states',
);

$err_msg = "";
foreach ($options as $var => $new_var) {
	if (!$report_class->set_option($new_var, get_array_var($_REQUEST, $var))) {
		$err_msg .= "Could not set option '$new_var' to '".convert_yesno_int(get_array_var($_REQUEST, $var))."'<br />";
	}
}


// convert report period to timestamps
if ($report_period=='custom' && !empty($syear) && !empty($eyear)) {
	// cgi compatibility
	$time_parts[0] = mktime($shour, $smin, $ssec, $smon, $sday, $syear);
	$time_parts[1] = mktime($ehour, $emin, $esec, $emon, $eday, $eyear);
} elseif(!empty($report_period)) {
	$time_parts = calculate_time($report_period, $start_time, $end_time);
} else {
	# Use time from t1 and t2 - when called from trends.cgi
	$time_parts = array($start_time, $end_time);
}

$start_date = $time_parts[0]; // used in calculations by lib_report
$end_date = $time_parts[1];  // used in calculations by lib_report
$str_start_date = date('Y-m-d H:i', $start_date); // used to set calendar
$str_end_date 	= date('Y-m-d H:i', $end_date); // used to set calendar

if('custom' == $report_period)
	$report_time_formatted  = "$str_start_date to $str_end_date";
else
	$report_time_formatted  = (isset($report_period_strings[$report_period]) ? $report_period_strings[$report_period] : $report_period);

if($rpttimeperiod != '')
	$report_time_formatted .= " - $rpttimeperiod";

$group_name = false;
switch ($report_type) {
	case 'hostgroups':
		$sub_type = "host";
		$hostgroup = $in_hostgroup;
		$group_name = $hostgroup;
		break;
	case 'servicegroups':
		$sub_type = "service";
		$servicegroup = $in_servicegroup;
		$group_name = $servicegroup;
		break;
	case 'hosts':
		$sub_type = "host";
		$hostname = $in_host;
		break;
	case 'services':
		$sub_type = "service";
		$service = $in_service;
		break;
	default:
		header('location: avail_setup.php');
		exit;
}
$report_class->set_option('host_name', $hostname);
$report_class->set_option('service_description', $service);

$scheduled_downtime_as_uptime     = get_array_var($_REQUEST, 'scheduleddowntimeasuptime');
$assume_initial_states            = get_array_var($_REQUEST, 'assumeinitialstates');
$assume_states_during_not_running = get_array_var($_REQUEST, 'assumestatesduringnotrunning');
$include_soft_states              = get_array_var($_REQUEST, 'includesoftstates');
$initial_assumed_host_state       = get_array_var($_REQUEST, 'initialassumedhoststate', $default_initial_assumed_host_state);
$initial_assumed_service_state    = get_array_var($_REQUEST, 'initialassumedservicestate', $default_initial_assumed_service_state);
$use_average = get_array_var($_REQUEST, 'use_average', 0);
$use_alias = get_array_var($_REQUEST, 'use_alias', 0);

$keep_logs                                = get_array_var($_REQUEST, 'keep_logs',                    $default_keep_logs);
$keep_logs_maxrows                        = (int)get_array_var($_REQUEST, 'keep_logs_maxrows',            $default_keep_logs_maxrows);
$keep_logs_states_masks = array();
$keep_logs_states_masks = get_array_var($_REQUEST, 'keep_logs_states', mask_to_state_masks((int)$default_keep_logs_states_mask));

if(!isset($_REQUEST['new_avail_report_setup']))
{
	$initial_assumed_host_state       = convert_assumed_state($initial_assumed_host_state, $sub_type);
	$initial_assumed_service_state    = convert_assumed_state($initial_assumed_service_state, $sub_type);

	$_REQUEST['initialassumedhoststate'] = $initial_assumed_host_state;
	$_REQUEST['initialassumedservicestate'] = $initial_assumed_service_state;
}

$dep_vars = array(
	'assumeinitialstates' => array(
		'initialassumedhoststate' => 'initial_assumed_host_state',
		'initialassumedservicestate' => 'initial_assumed_service_state'
	)
);

foreach ($dep_vars as $check => $set)
	if (isset($_REQUEST[$check]) && !empty($_REQUEST[$check]))
		foreach ($set as $dep => $key)
		{
			if (!$report_class->set_option($key, $_REQUEST[$dep]))
			{
				$err_msg .= "Could not set option '".$key."' to '".$_REQUEST[$dep]."'<br />";
			}
		}

$get_vars = "&report_period=$report_period";

foreach ($options as $var => $new_var)
	$get_vars .= '&'.$var.'='.convert_yesno_int(get_array_var($_REQUEST, $var));


$data_arr = $group_name!== false
	? expand_group_request($group_name, substr($report_type, 0, strlen($report_type)-1), $start_date, $end_date)
	: $report_class->get_uptime(false, false, $start_date, $end_date, $hostgroup, $servicegroup);

$get_vars .= "&initialassumedhoststate=$initial_assumed_host_state";
$get_vars .= "&initialassumedservicestate=$initial_assumed_service_state";

$tpl = new Template('templates/index.tpl.php'); // this is the outer template
$tpl->assign('title', 'Availability Report');
$tpl->assign('report_time_formatted', $report_time_formatted);
$tpl->assign('avail_id', $avail_id);
$tpl->assign('avail_info', $avail_info);
$tpl->assign('status_msg', $status_msg);
$tpl->assign('msg_type', $msg_type);
$tpl->assign('op5common_path', $op5common_path);

$report_template_check = !empty($in_hostgroup) ? true : ((count($in_host) > 1) ? true : false);

$tpl->assign('report_template_check', $report_template_check);
//$tpl->assign('in_host', $in_host);

# The following part is not needed when creating csv output
# but is placed here because we want it in both the elseif and else
# part later in the code. Since function calls seems to be somewhat
# hard to get working when creating PDF reports, it is placed here.
$html_options[] = array('hidden', 'report_type', $report_type);
$selected_objects = ""; // string containing selected objects for this report

# pass selected calculation method on to report options
$html_options[] = array('hidden', 'use_average', $use_average);
$html_options[] = array('hidden', 'use_alias', $use_alias);
$html_options[] = array('hidden', 'keep_logs', $keep_logs);
$html_options[] = array('hidden', 'keep_logs_maxrows', $keep_logs_maxrows);
foreach ($keep_logs_states_masks as $mask) {
	$html_options[] = array('hidden', 'keep_logs_states[]', $mask);
}

# $objects is an array used when creating report_error page (template).
# Imploded into $missing_objects
$objects = false;
if (($report_type == 'hosts' || $report_type == 'services')) {
	if (is_array($in_host)) {
		foreach ($in_host as $host) {
			$html_options[] = array('hidden', 'host_name[]', $host);
			$selected_objects .= "&host_name[]=".$host;
			$objects[] = $host;
		}
	}
	if (is_array($in_service)) {
		foreach ($in_service as $svc) {
			$html_options[] = array('hidden', 'service_description[]', $svc);
			$selected_objects .= "&service_description[]=".$svc;
			$objects[] = $svc;
		}
	}
} else {
	if (is_array($hostgroup)) {
		foreach ($hostgroup as $h_gr) {
			$html_options[] = array('hidden', 'hostgroup[]', $h_gr);
			$selected_objects .= "&hostgroup[]=".$h_gr;
			$objects[] = $h_gr;
		}
	}
	if (is_array($servicegroup)) {
		foreach ($servicegroup as $s_gr) {
			$html_options[] = array('hidden', 'servicegroup[]', $s_gr);
			$selected_objects .= "&servicegroup[]=".$s_gr;
			$objects[] = $s_gr;
		}
	}
}

if ($in_csvoutput) {
	// print csv
	if (!empty($data_arr)) {
		header("Content-disposition: attachment; filename=availability.csv");
		header("Content-type: text/csv");
		$csv = csv_header($sub_type);
		// =========== GROUPS ===========
		if ($group_name !== false) { // We have a host- or servicegroup
			// Add new csv header fields
			$group_type = !empty($in_hostgroup) ? "HOST_GROUP, " : "SERVICE_GROUP, ";
			$csv = $group_type . $csv;
			foreach ($data_arr as $data_arr_group) {
				// Add group name to csv output
				$csv_group_name = $data_arr_group['groupname'];
				foreach ($data_arr_group as $k => $data) {
					if ($k === 'tot_time' || $k === 'source' || $k === 'states' || $k === 'groupname')
						continue;
					if (!empty($data['states'])) {
						$csv .= '"'.$csv_group_name.'", ';
						$csv .= csv_content($data['states'], $sub_type)."\n";
					}
				}
			}
		} else {
			if (!get_array_var($data_arr, 0)) {
				// if we can't find item with index 0, we
				// are dealing with a single item and should
				// skip the foreach loop
				$csv .= csv_content($data_arr['states'], $sub_type)."\n";
			} else {
				foreach ($data_arr as $k => $data) {
					if ($k === 'tot_time' || $k === 'source' || $k === 'states' || $k === 'groupname')
						continue;
					$csv .= csv_content($data['states'], $sub_type)."\n";
				}
			}
		}
		echo $csv;
		exit;
	} else {
		$tpl->assign('content', "No data found for selection...<br />Use the browsers' back button to change report settings.");
	}
} elseif (empty($data_arr) || (sizeof($data_arr)==1 && empty($data_arr[0]))) {
	# report is empty

	# what objects were submitted?
	$missing_objects = false;
	if (!empty($objects)) {
		$missing_objects = implode('<li>', $objects);
	}
	$tpl->assign('report_header', '<br /><h3>Empty report</h3>');
	$error_tpl = new Template('templates/report_error.tpl.php');
	$error_msg = "The selected objects for this ".ucfirst(substr($report_type, 0, strlen($report_type)-1))." report doesn't seem to exist anymore.<br />
	The reason for this is most likely that they have been removed or renamed in your configuration.";
	if (!empty($missing_objects)) {
		$error_msg .= "<br /><br /><strong>Missing objects:</strong> <ul>" . $missing_objects . "</ul>";
	}
	$error_tpl->assign('report_error', $error_msg);
	$tpl->assign('error_msg', $error_tpl);
} else {
	$html_options[] = array('hidden', 'rpttimeperiod', $rpttimeperiod);

	if($include_soft_states)
		$html_options[] = array('hidden', 'includesoftstates', $include_soft_states);

	if($assume_states_during_not_running)
		$html_options[] = array('hidden', 'assumestatesduringnotrunning', $assume_states_during_not_running);

	$report_options 		= new Template('templates/report_options.tpl.php');
	$report_options_top = new Template('templates/report_options_top.tpl.php');
	// Assign local variables to variables visible to template
	$report_options->assign('html_options', $html_options);
	$report_options->assign('str_end_date', $str_end_date);
	$report_options->assign('str_start_date', $str_start_date);
	$report_options->assign('report_time_formatted', $report_time_formatted);
	if (!empty($avail_info)) {
		$report_options->assign('avail_info', $avail_info);
	}
	$report_options->assign('avail_id', $avail_id);
	$report_options->assign('report_period', $report_period);
	$report_options->assign('selected_objects', $selected_objects.$get_vars);

	// assing the same info for the report_options_top template. the content must be the same
	$report_options_top->assign('html_options', $html_options);
	$report_options_top->assign('str_end_date', $str_end_date);
	$report_options_top->assign('str_start_date', $str_start_date);
	$report_options_top->assign('report_time_formatted', $report_time_formatted);
	if (!empty($avail_info)) {
		$report_options_top->assign('avail_info', $avail_info);
	}
	$report_options_top->assign('avail_id', $avail_id);
	$report_options_top->assign('report_period', $report_period);
	$report_options_top->assign('selected_objects', $selected_objects.$get_vars);

	// fetch names for all saved reports
	$old_config_names = get_all_avail_config_names();
	$tpl->assign('old_config_names', $old_config_names);

	// Fetch info on available scheduling periods
	$scheduled_info = false;
	if (!empty($avail_id)) {
		$periods_res = get_available_autoreport_periods();
		$report_options->assign('periods_res', $periods_res);
		$report_options_top->assign('periods_res', $periods_res);
		$scheduled_info = report_is_scheduled($avail_id);
		$report_options->assign('scheduled_info', $scheduled_info);
		$report_options_top->assign('scheduled_info', $scheduled_info);
	}

	$initial_assumed_host_state_options = '';
	foreach($initial_assumed_host_states as $host_state_value => $host_state_txt)
	{
		$sel = ($host_state_value == $initial_assumed_host_state ? 'selected="selected"':'');
		$initial_assumed_host_state_options .= "<option value='$host_state_value' $sel>$host_state_txt</option>";
	}

	$initial_assumed_service_state_options = '';
	foreach($initial_assumed_service_states as $service_state_value => $service_state_txt)
	{
		$sel = ($service_state_value == $initial_assumed_service_state ? 'selected="selected"':'');
		$initial_assumed_service_state_options .= "<option value='$service_state_value' $sel>$service_state_txt</option>";
	}
	$report_options->assign('initial_assumed_host_state_options', $initial_assumed_host_state_options);
	$report_options->assign('initial_assumed_service_state_options', $initial_assumed_service_state_options);
	// same for the top template
	$report_options_top->assign('initial_assumed_host_state_options', $initial_assumed_host_state_options);
	$report_options_top->assign('initial_assumed_service_state_options', $initial_assumed_service_state_options);

	$tpl->assign('report_options', $report_options);
	$tpl->assign('report_options_top', $report_options_top);
	$tpl->assign('report_type', $report_type);
	$template_values = false;
	if (!empty($err_msg))
		$tpl->assign('err_msg', $err_msg);

	$csv_link = get_csv_link(basename($_SERVER['PHP_SELF']), "csvoutput=1".$selected_objects.$get_vars."&report_type=".$report_type);
	if(!isset($_REQUEST['generating_pdf']))
		$pdf_link = get_pdf_link('avail');
	else
		$pdf_link = '';


	$host_graph_items = array('TOTAL_TIME_UP' => 'Up',
			'TOTAL_TIME_DOWN' => 'Down',
			'TOTAL_TIME_UNREACHABLE' => 'Unreachable',
			'TOTAL_TIME_UNDETERMINED' => 'Undetermined');
	$service_graph_items = array('TOTAL_TIME_OK' => 'Ok',
			'TOTAL_TIME_WARNING' => 'Warning',
			'TOTAL_TIME_UNKNOWN' => 'Unknown',
			'TOTAL_TIME_CRITICAL' => 'Critical',
			'TOTAL_TIME_UNDETERMINED' => 'Undetermined');
	$graph_filter = ${$sub_type.'_graph_items'};

	# hostgroups / servicegroups
	if (isset($data_arr[0])) {

		$header_tpl = new Template('templates/report_header.tpl.php');
		$header_tpl->assign('report_time_formatted', $report_time_formatted);
		$header_tpl->assign('csv_link', $csv_link);
		$header_tpl->assign('pdf_link', $pdf_link);
		$header_tpl->assign('str_start_date', $str_start_date);
		$header_tpl->assign('str_end_date', $str_end_date);
		$header_tpl->assign('use_average', $use_average);
		$header_tpl->assign('use_alias', $use_alias);
		//$header_tpl->assign('header_string', ucfirst($report_type)." state breakdown: ".$str_start_date." to ".$str_end_date);
		$tpl->assign('report_header', $header_tpl);

		if ($group_name) {
			foreach ($data_arr as $data) {
				if (empty($data))
					continue;
				array_multisort($data);
				$template_values[] = get_multiple_state_info($data, $sub_type, $get_vars, $time_parts[0], $time_parts[1]);
			}
		} else {
			array_multisort($data_arr);
			$template_values[] = get_multiple_state_info($data_arr, $sub_type, $get_vars, $time_parts[0], $time_parts[1]);
		}
		for($i=0,$num_groups=count($template_values)  ; $i<$num_groups ; $i++)
		{
			reorder_by_host_and_service($template_values[$i]);
		}
		$body = new Template('templates/multiple_'.$sub_type.'_states.tpl.php'); // This is the inner template
		$body->assign('multiple_states', $template_values);
		$body->assign('hide_host', false);
		$body->assign('use_average', $use_average);
		$body->assign('use_alias', $use_alias);
		$body->assign('report_time_formatted', $report_time_formatted);
		$tpl->assign('content', $body);

		$piechart = new Template('templates/pie_chart.tpl.php');
		$piechart->assign('report_time_formatted', $report_time_formatted);

		// ===== SETUP PIECHART VALUES =====
		$image_data = array();
		$log_data = array();
		foreach($graph_filter as $key => $val) { $image_data[strtoupper($val)] = 0; }

		# We've either got
		# 1) custom group
		# 2) hostgroup / servicegroup

		$groups_added = 0;
		$pie_groupname = false;
		if(!isset($data_arr['groupname'])) { # actual hostgroup/servicegroup.
			foreach($data_arr as $data) { # for every group
				$added_group = false;
				if (is_array($data['states'])) {
					foreach ($graph_filter as $key => $val) {
						if ($data['states'][$key]!=0) {
							if (isset($image_data[$groups_added][strtoupper($val)])) {
								$image_data[$groups_added][strtoupper($val)] += $data['states'][$key];
							} else {
								$image_data[$groups_added][strtoupper($val)] = $data['states'][$key];
							}
							$pie_groupname[$groups_added] = $data['groupname'];
							$added_group = true;
						}
					}
					$log = get_array_var($data, 'log');
					if ($log !== false) {
						$log_data[] = array('log' => $data['log'], 'log_maxrows' => $data['log_maxrows'], 'source' => $data['source'], 'name' => $data['groupname']);
					}
				}
				if($added_group)
					$groups_added++;
			}
		}
		else {
			$added_group = false;
			if (is_array($data_arr['states'])) {
				foreach ($graph_filter as $key => $val) {
					if ($data_arr['states'][$key]!=0)
					{
						if (isset($image_data[0][strtoupper($val)])) {
							$image_data[0][strtoupper($val)] += $data_arr['states'][$key];
						} else {
							$image_data[0][strtoupper($val)] = $data_arr['states'][$key];
						}
						$added_group = true;
					}
				}
				$log = get_array_var($data_arr, 'log');
				if ($log !== false) {
					if (isset($data_arr['groupname']) && ! empty($data_arr['groupname']))
						$name = $data_arr['groupname'];
					else
						$name = $data_arr['source'];

					$log_data[] = array('log' => $data_arr['log'], 'log_maxrows' => $data_arr['log_maxrows'], 'source' => $data_arr['source'], 'name' => $name);
				}
			}
			if($added_group)
				$groups_added++;
		}
		if ($groups_added > 0) {
			foreach($graph_filter as $key => $val) {
				for($i = 0; $i < $groups_added; $i++) {
					if(isset($image_data[$i][strtoupper($val)]) && $image_data[$i][strtoupper($val)] == 0)
						unset($image_data[$i][strtoupper($val)]);
					else {
						if (isset($image_data[$i][strtoupper($val)]))
							$image_data[$i][strtoupper($val)] /= $groups_added;
					}
				}
			}
			for($i = 0; $i < $groups_added; $i++) {
				$data_str[$i]['img'] = base64_encode(serialize($image_data[$i]));
				$data_str[$i]['host'] = $pie_groupname[$i];
			}

			$piechart->assign('data_str', $data_str);

			$tpl->assign('piechart', $piechart);
		}

	    # Setup log entries
		$log_template = new Template('templates/log_multiple.tpl.php');
		$log_template->assign('log_arr', $log_data);
		$log_template->assign('type', $sub_type);
		# $log_template->assign('source', $data['source']);
		$log_template->assign('report_time_formatted', $report_time_formatted);
		$tpl->assign('log_content', $log_template);

	} else {

		$image_data = false;
		$data_str = '';
		if (!empty($data_arr)) {
			$data = $data_arr;

			$header_tpl = new Template('templates/report_header.tpl.php');
			$header_tpl->assign('header_string', "State breakdown for ".$data['source']);
			$header_tpl->assign('report_time_formatted', $report_time_formatted);
			$header_tpl->assign('str_start_date', $str_start_date);
			$header_tpl->assign('str_end_date', $str_end_date);
			$header_tpl->assign('csv_link', $csv_link);
			$header_tpl->assign('pdf_link', $pdf_link);
			$header_tpl->assign('use_average', $use_average);
			$header_tpl->assign('use_alias', $use_alias);
			$tpl->assign('report_header', $header_tpl);
			$avail = new Template('templates/avail.tpl.php');
			$avail_data = print_state_breakdowns($data['source'], $data['states'], $report_type);
			$avail->assign('avail_data', $avail_data);
			$avail->assign('source', $data['source']);
			$avail->assign('report_time_formatted', $report_time_formatted);
			$avail->assign('testbutton', build_testcase_form($data[';testcase;']));

			$avail->assign('header_string', ucfirst($report_type)." state breakdown");

			$piechart = new Template('templates/pie_chart.tpl.php');
			$piechart->assign('report_time_formatted', $report_time_formatted);

			// ===== SETUP PIECHART VALUES =====
			if (is_array($data['states'])) {
				foreach ($graph_filter as $key => $val) {
					if ($data['states'][$key]!=0)
						$image_data[strtoupper($val)] = $data['states'][$key];
				}
			}
			if ($image_data) {
				$data_str = base64_encode(serialize($image_data));
				//$avail->assign('data_str', $data_str);
				$piechart->assign('data_str', $data_str);
				$piechart->assign('source', $data['source']);
			}

			$tpl->assign('content', $avail);
			$tpl->assign('piechart', $piechart);

			if ($sub_type=='host') {
				$service_states = print_states_for_services($data_arr['source'], $start_date, $end_date, $report_type);
				if ($service_states !== false) {
					$template_values[] = get_multiple_state_info($service_states, 'service', $get_vars, $time_parts[0], $time_parts[1]);
					$svc_states = new Template('templates/multiple_service_states.tpl.php');
					$svc_states->assign('header_string', "Service state breakdown");
					$svc_states->assign('multiple_states', $template_values);
					$svc_states->assign('hide_host', true);
					$svc_states->assign('use_average', $use_average);
					$svc_states->assign('use_alias', $use_alias);
					$svc_states->assign('source', $data['source']);
					$svc_states->assign('report_time_formatted', $report_time_formatted);
					$tpl->assign('svc_content', $svc_states);
				}
			}
			// fetch and display log messages
			$log = get_array_var($data, 'log');
			if ($log !== false) {
				$log_template = new Template('templates/log.tpl.php');
				$log_template->assign('log', $log);
				$log_template->assign('log_maxrows', get_array_var($data, 'log_maxrows'));
				$log_template->assign('type', $sub_type);
				$log_template->assign('source', $data['source']);
				$log_template->assign('report_time_formatted', $report_time_formatted);
				$tpl->assign('log_content', $log_template);
			}


			$t1 = $time_parts[0];
			$t2 = $time_parts[1];


			# assume default values for the following
			$assume_state_retention = 'yes';
			$backtrack = 1;

			$links = array();
			$trends_img_params = '';
			$trends_link_params = '';
			$downtime       = convert_yesno_int($scheduled_downtime_as_uptime);
			$assume_initial = convert_yesno_int($assume_initial_states);
			$not_running    = convert_yesno_int($assume_states_during_not_running);
			$soft_states    = convert_yesno_int($include_soft_states);

			// convert "First Real State" (-3) to value returned from report_class
			// other values are converted to old cgi value equivalent
			$trends_assumed_initial_host_state 		= $initial_assumed_host_state == -3 ? $report_class->initial_state : convert_assumed_state($initial_assumed_host_state, $sub_type, false);
			$trends_assumed_initial_service_state 	= $initial_assumed_service_state == -3 ? $report_class->initial_state : convert_assumed_state($initial_assumed_service_state, $sub_type, false);

			switch($report_type) {
			  case 'hosts':
				  # only meaningful to print these links if only one host selected
				  if(count($hostname) != 1)
					  break;

				  $host = $hostname[0];

				  /*$downtime       = convert_yesno_int($scheduled_downtime_as_uptime);
				  $assume_initial = convert_yesno_int($assume_initial_states);
				  $not_running    = convert_yesno_int($assume_states_during_not_running);
				  $soft_states    = convert_yesno_int($include_soft_states);*/

				  $all_avail_params = "report_type=$report_type".
							 "&amp;host_name=all".
							 "&amp;report_period=$report_period".
							 "&amp;rpttimeperiod=$rpttimeperiod".
							 "&amp;start_time=$start_date".
							 "&amp;end_time=$end_date".
							 "&amp;initialassumedhoststate=$initial_assumed_host_state".
							 "&amp;initialassumedservicestate=$initial_assumed_service_state";

				  	if($downtime)			$all_avail_params .= "&amp;scheduleddowntimeasuptime=$downtime";
				  	if($assume_initial)	$all_avail_params .= "&amp;assumeinitialstates=$assume_initial";
					if($not_running)		$all_avail_params .= "&amp;assumestatesduringnotrunning=$not_running";
					if($soft_states)		$all_avail_params .= "&amp;includesoftstates=$soft_states";

				$links[$_SERVER['PHP_SELF']."?$all_avail_params"] = 'View availability report for all hosts';

				$trends_params = "host=$host".
								"&amp;t1=$t1".
								"&amp;t2=$t2".
								"&amp;assumestateretention=$assume_state_retention".
								"&amp;assumeinitialstates=".convert_yesno_int($assume_initial_states, false).
								"&amp;includesoftstates=".convert_yesno_int($include_soft_states, false).
								"&amp;assumestatesduringnotrunning=".convert_yesno_int($assume_states_during_not_running, false).
								"&amp;initialassumedhoststate=".$trends_assumed_initial_host_state.
								"&amp;backtrack=$backtrack";

				$trends_img_params = "{$cgibin_path}trends.cgi?".
											"host=$host".
											"&amp;createimage&amp;smallimage".
											"&amp;t1=$t1".
											"&amp;t2=$t2".
											"&amp;assumestateretention=$assume_state_retention".
											"&amp;assumeinitialstates=".convert_yesno_int($assume_initial_states, false).
											"&amp;includesoftstates=".convert_yesno_int($include_soft_states, false).
											"&amp;assumestatesduringnotrunning=".convert_yesno_int($assume_states_during_not_running, false).
											"&amp;initialassumedhoststate=".$trends_assumed_initial_host_state.
											"&amp;backtrack=$backtrack";

				$trends_link_params = "{$cgibin_path}trends.cgi?".
											"host=$host".
											"&amp;t1=$t1".
											"&amp;t2=$t2".
											"&amp;assumestateretention=$assume_state_retention".
											"&amp;assumeinitialstates=".convert_yesno_int($assume_initial_states, false).
											"&amp;includesoftstates=".convert_yesno_int($include_soft_states, false).
											"&amp;assumestatesduringnotrunning=".convert_yesno_int($assume_states_during_not_running, false).
											"&amp;initialassumedhoststate=".$trends_assumed_initial_host_state.
											"&amp;backtrack=$backtrack";



				$links["{$cgibin_path}trends.cgi?$trends_params"] = 'View trends for this host';

				$histogram_params = "host=$host&amp;t1=$t1&amp;t2=$t2&amp;assumestateretention=$assume_state_retention";

				$links["{$cgibin_path}histogram.cgi?$histogram_params"] = 'View alert histogram for this host';
				$links["{$cgibin_path}status.cgi?host=$host"] = 'View status detail for this host';
				$links["{$cgibin_path}history.cgi?host=$host"] = 'View alert history for this host';
				$links["{$cgibin_path}notifications.cgi?host=$host"] = 'View notifications for this host';
				break;

			  case 'services':

				list($host, $service) = split(';',$service[0]);

				$avail_params = "&show_log_entries".
							 "&amp;t1=$t1".
							 "&amp;t2=$t2".
							 "&amp;report_period=$report_period".
							 "&amp;rpttimeperiod=$rpttimeperiod".
							 "&amp;backtrack=$backtrack".
							 "&amp;assumestateretention=$assume_state_retention".
							 "&amp;assumeinitialstates=".convert_yesno_int($assume_initial_states, false).
							 "&amp;assumestatesduringnotrunning=".convert_yesno_int($assume_states_during_not_running, false).
							 "&amp;initialassumedhoststate=-1".
							 "&amp;initialassumedservicestate=-1".
							 "&amp;show_log_entries".
							 "&amp;showscheduleddowntime=yes";


					if($downtime)			$avail_params .= "&amp;scheduleddowntimeasuptime=$downtime";
					if($assume_initial)	$avail_params .= "&amp;assumeinitialstates=$assume_initial";
					if($not_running)		$avail_params .= "&amp;assumestatesduringnotrunning=$not_running";
					if($soft_states)		$avail_params .= "&amp;includesoftstates=$soft_states";

				$trends_params = "host=$host".
								"&amp;t1=$t1".
								"&amp;t2=$t2".
								"&amp;assumestateretention=$assume_state_retention".
								"&amp;assumeinitialstates=".convert_yesno_int($assume_initial_states, false).
								"&amp;includesoftstates=".convert_yesno_int($include_soft_states, false).
								"&amp;assumestatesduringnotrunning=".convert_yesno_int($assume_states_during_not_running, false).
								"&amp;initialassumedservicestate=".$trends_assumed_initial_service_state.
								"&amp;backtrack=$backtrack";

				$trends_img_params = "{$cgibin_path}trends.cgi?".
											"host=$host".
											"&amp;service=$service".
											"&amp;createimage&amp;smallimage".
											"&amp;t1=$t1".
											"&amp;t2=$t2".
											"&amp;assumestateretention=$assume_state_retention".
											"&amp;assumeinitialstates=".convert_yesno_int($assume_initial_states, false).
											"&amp;includesoftstates=".convert_yesno_int($include_soft_states, false).
											"&amp;assumestatesduringnotrunning=".convert_yesno_int($assume_states_during_not_running, false).
											"&amp;initialassumedservicestate=".$trends_assumed_initial_service_state.
											"&amp;backtrack=$backtrack";

				$trends_link_params = "{$cgibin_path}trends.cgi?".
											"host=$host".
											"&amp;service=$service".
											"&amp;t1=$t1".
											"&amp;t2=$t2".
											"&amp;assumestateretention=$assume_state_retention".
											"&amp;assumeinitialstates=".convert_yesno_int($assume_initial_states, false).
											"&amp;includesoftstates=".convert_yesno_int($include_soft_states, false).
											"&amp;assumestatesduringnotrunning=".convert_yesno_int($assume_states_during_not_running, false).
											"&amp;initialassumedservicestate=".$trends_assumed_initial_service_state.
											"&amp;backtrack=$backtrack";


				$histogram_params     = "host=$host&amp;service=$service&amp;t1=$t1&amp;t2=$t2&amp;assumestateretention=$assume_state_retention";
				$history_params       = "host=$host&amp;service=$service";
				$notifications_params = "host=$host&amp;service=$service";


				$links[$_SERVER['PHP_SELF']."?host=$host$avail_params"] 			= 'View Availability Report For This Host';
				$links[$_SERVER['PHP_SELF']."?host=null&amp;service=all$avail_params"] = 'View Availability Report For All Services';
				$links["{$cgibin_path}trends.cgi?$trends_params"."&amp;service=$service"] = 'View Trends For This Service';
				$links["{$cgibin_path}histogram.cgi?$histogram_params"] 		= 'View Alert Histogram For This Service';
				$links["{$cgibin_path}history.cgi?$history_params"] 			= 'View Alert History This Service';
				$links["{$cgibin_path}notifications.cgi?$notifications_params"] = 'View Notifications For This Service';

				 break;
		  }
		  $tpl->assign('links', $links);
		  $tpl->assign('trends', $trends_img_params);
		  $tpl->assign('trends_link', $trends_link_params);
		  $tpl->assign('source', $data['source']);
		  $tpl->assign('header_string', "State breakdown for ".$data['source']);
		} else {
			// Missing data to create report
			$tpl->assign('content', 'No data found for selection...');
		}
	}
}

# CHANGE THESE TO REBRAND
$tpl->assign('generated_by_txt', 'Generated by');
$tpl->assign('logo_src', 'company_logo.gif');
$tpl->assign('logo_alt', 'op5 Monitor');

echo $tpl->fetch();
# print "<pre>".print_r($_REQUEST, true)."</pre>";
?>
