<?php

require_once 'lib_reports.php';
require_once 'lib_gui.php';
require_once '/opt/monitor/op5/auto-reports/lib_auto.php';

set_time_limit(7200); # 2 hours

# CONFIGURATION SET FOR HTML2PS RUN
$GLOBALS['g_config'] = array
(
	'cssmedia'     => 'projection',
	'renderimages' => true,
	'renderforms'  => false,
	'renderlinks'  => false,
	'renderfields'  => false,
	'mode'         => 'html',
	'debugbox'     => false,
	'draw_page_border' => false,
	'smartpagebreak' => true,
);

$valid_includes = array('avail_result.php', 'sla.php');
$output_filename = tempnam('/tmp', 'autoreports_');


$_REQUEST['generating_pdf'] = 1;
switch($_REQUEST['report'])
{
	case 'avail':

		$basepath = '/var/www/html/monitor/op5/reports/gui';
		$baseurl = "$basepath/avail_result.php";
		break;

	case 'sla':

		$basepath = '/var/www/html/monitor/op5/reports/gui/sla';
		$baseurl = "$basepath/sla.php";
		break;

	default:
		die("Invalid report type");

}

parse_html2ps_config_file(HTML2PS_DIR.'html2ps.config');

$media = Media::predefined("A4");
$media->set_landscape(false);
$media->set_pixels(1024);
$media->set_margins(array('left' => 0, 'right' => 0, 'top' => 0, 'bottom' => 0));


$pipeline = new Pipeline;
$pipeline->configure($GLOBALS['g_config']);

$pipeline->fetchers[] = new fetcher_report($basepath, array(), $valid_includes);
$pipeline->destination = new MyDestinationDownload($output_filename);
$pipeline->data_filters[] = new DataFilterHTML2XHTML;
$pipeline->pre_tree_filters = array(new PreTreeFilterHTML2PSFields());
$pipeline->parser = new ParserXHTML();
$pipeline->layout_engine = new LayoutEngineDefault;
$pipeline->output_driver = new OutputDriverFPDF($media);


$options = array(
	'rpttimeperiod' => 'report_timeperiod',
	'scheduleddowntimeasuptime' => 'scheduled_downtime_as_uptime',
	'assumestatesduringnotrunning' => 'assume_states_during_not_running',
	'includesoftstates' => 'include_soft_states',
	'assumeinitialstates' => 'assume_initial_states',
	'use_average' =>'use_average',
	'keep_logs' => 'keep_logs',
	'keep_logs_maxrows' => 'keep_logs_maxrows',
	'keep_logs_states' => 'keep_logs_states'
);

$pipeline->process($baseurl, $media);

?>
