$(document).ready(function(){
	// create filter keyup events
	$('#filter_svc').keyup(function(){filter_select('filter_svc');});
	$('#filter_host').keyup(function(){filter_select('filter_host');});
	$('#filter_hostgroup').keyup(function(){filter_select('filter_hostgroup');});
	$('#filter_servicegroup').keyup(function(){filter_select('filter_servicegroup');});

	// Timeout for filter is cleared by keydown event
	$('#filter_svc').keydown(function(){clearTimeout(timeOut);});
	$('#filter_host').keydown(function(){clearTimeout(timeOut);});
	$('#filter_hostgroup').keydown(function(){clearTimeout(timeOut);});
	$('#filter_servicegroup').keydown(function(){clearTimeout(timeOut);});

	// create 'Clear' click events
	$('#clear_svcfilter').click(function(){clear_filter('svc')});
	$('#clear_hostfilter').click(function(){clear_filter('host')});
	$('#clear_hostgroupfilter').click(function(){clear_filter('hostgroup')});
	$('#clear_servicegroupfilter').click(function(){clear_filter('servicegroup')});

	// toggle filter visibility for hostgroups
	$('#hostgroupfilter').hide();
	$('#hostgroupfilter_toggle').click(function(){
		$('#hostgroupfilter').toggle('fast', function(){
			show_hide_filter('hostgroup');
		});
	});

	// toggle filter visibility for hosts
	$('#hostfilter').hide();
	$('#hostfilter_toggle').click(function(){
		$('#hostfilter').toggle('fast', function(){
			show_hide_filter('host');
		});
	});

	// toggle filter visibility for services
	$('#svcfilter').hide();
	$('#svcfilter_toggle').click(function(){
		$('#svcfilter').toggle('fast', function(){
			show_hide_filter('svc');
		});
	});

	// toggle filter visibility for servicegroups
	$('#servicegroupfilter').hide();
	$('#servicegroupfilter_toggle').click(function(){
		$('#servicegroupfilter').toggle('fast', function(){
			show_hide_filter('servicegroup');
		});
	});
});

/**
*	Start the timeout filter trigger
*/
function filter_select(fieldname)
{
	timeOut = setTimeout("idle_filter('" + fieldname + "')", idleTime);
}

var idleTime = 600;		// required idle time before filtering starts
var timeOut = false;	// global variable to hold current timeOut object

/**
*	Filter items in left select box from entered filter text
*/
function idle_filter(fieldname) {
	var arg = $('input[name=' + fieldname + ']').attr('arg_type');
	var val = $('input[name=' + fieldname + ']').val();

	// name of selected objects
	var field_obj = new field_maps();
	var field_name = field_obj.map[arg];

	// name of available objects
	var tmp_obj = new field_maps3();
	var tmp_name = tmp_obj.map[arg];
	var left_cnt = $('select[name^=' + tmp_name + '] option').length;
	var cnt = 0;
	regexp = new RegExp(val, 'i');
	var i = 0;
	$('select[name^=' + tmp_name + '] option').filter(function(){
		if (regexp.test($(this).val())) {
			$(this).show();
			cnt++;
		} else {
			$(this).hide();
			i++;
		}
	});

	// show info on matched items
	var match_str = '';
	if (cnt == left_cnt && val=='') {
		$('#' + fieldname + 'matches').text('');
	} else {
		if (cnt==1) {
			match_str = cnt + ' match';
		} else {
			if (cnt != 0) {
				match_str = cnt + ' matches';
			} else {
				match_str = '<strong>no matches</strong>';
			}
		}
		$('#' + fieldname + 'matches').html('<i>(' + match_str + ')</i>');
	}
}

/**
*	Remove current filter and show all items
*/
function clear_filter(fieldname)
{
	$('input[name=filter_' + fieldname + ']').val('');
	filter_select('filter_' + fieldname);
}

/**
*	Change toggle text and icon for filters
*/
function show_hide_filter(fieldname)
{
	var link_txt = $('#' + fieldname + 'filterlink_txt').text();
	if (link_txt == 'show filter') {
		link_txt = 'hide filter';
		$('#' + fieldname + 'filter_img').attr('src', 'icons/arrows/grey-down.gif');
	} else {
		link_txt = 'show filter';
		$('#' + fieldname + 'filter_img').attr('src', 'icons/arrows/grey.gif');
	}
	$('#' + fieldname + 'filterlink_txt').text(link_txt);
}
