$(document).ready(function(){
	// ajax post form options
	var options = {
		target:			'#response',		// target element(s) to be updated with server response
		beforeSubmit:	validate_form,	// pre-submit callback
		success:		show_response	// post-submit callback
	};

	// save report when already created
	$('#schedule_report_form').submit(function() {
		$(this).ajaxSubmit(options);
		return false;
	});
	$(".delete_report").click( function() {
		schedule_delete(this.id);
	});
});

function show_new_schedule_form()
{
	$('#new_schedule_form_area').show();
}

function show_request(formData, jqForm, options)
{
	var queryString = $.param(formData);
	alert('About to submit: \n\n' + queryString);
	return true;
}

function show_response(responseText, statusText)
{
	var message_div_start = '<div id="statusmsg">';
	var ok_img = '<img src="icons/16x16/shield-ok.png" alt="OK" title="OK"> &nbsp;'
	var message_div_end = '</div>';
	var time = 3000;
	$('#response').remove();
	$('body').prepend('<div id="response"></div>');
	if (isNaN(responseText)) { // an error occurred
		$('#response').css("position", "absolute").css('top', '11px').css('left', '200px').html(message_div_start + 'An error occurred when saving scheduled report' + message_div_end);
		time = 6000;
	} else {
		var report_id = $('#report_id').fieldValue();
		if (report_id[0]) { // updated
			$('#response').css('background','#f4f4ed url(css/images/icons/32x32/shield-ok.png) 7px 7px no-repeat').css("position", "relative").css('top', '0px').css('width','748px').css('left', '0px').css('padding','15px 2px 15px 50px ').html('Your schedule has been successfully updated');
		} else { //new save
			$('#response').css('background','#f4f4ed url(css/images/icons/32x32/shield-ok.png) 7px 7px no-repeat').css("position", "relative").css('top', '0px').css('width','748px').css('left', '0px').css('padding','15px 2px 15px 50px ').html('Your schedule has been successfully created');
			$('#schedule_report_table').append(create_new_schedule_rows(responseText));
			$('#schedule_report_table').show();
			schedule_is_visible = true;
			$('#schedule_report_form').clearForm();
			setup_editable();
			tb_remove();
			nr_of_scheduled_instances++;
			if (nr_of_scheduled_instances==1) {
				// add 'Vew schedules' Button
				$('#view_add_schedule').append('<input type="button" id="show_schedule" alt="#TB_inline?height=500&width=550&inlineId=schedule_report" class="button view-schedules20 thickbox" value="View schedule">');
				tb_init('#show_schedule');
			}
		}
	}
	setTimeout('hide_message()', time);
}

function create_new_schedule_rows(id)
{
	var return_str = '';
	var f = document.forms['schedule_report_form'];
	return_str += '<tr id="report-' + id + '">';
	return_str += '<td class="period_select" title="Double click to edit" id="period_id-' + id + '">' + $('#period option:selected').text(); + '</td>';
	return_str += '<td class="iseditable" title="Double click to edit" id="recipients-' + id + '">' + f.recipients.value + '</td>';
	return_str += '<td class="iseditable" title="Double click to edit" id="filename-' + id + '">' + f.filename.value + '</td>';
	return_str += '<td class="iseditable_txtarea" title="Double click to edit" id="description-' + id + '">' + f.description.value + '</td>';
	return_str += '<td class="delete_report" onclick="schedule_delete(' + id + ');" id="' + id + '"><img src="icons/cross_12x12.gif"></td></tr>';
	return return_str;
}

function hide_message()
{
	$('#response').hide();
}
/**
*	Make sure all values are properly entered
*/
function validate_form(formData, jqForm, options) {
//	show_request(formData, jqForm, options);
	var interval = $('#period').fieldValue();
	var recipients_tmp = $('#recipients').fieldValue();
	var recipients = recipients_tmp[0];
	var filename = $('#filename').fieldValue();
	var description = $('#description').fieldValue();
	var saved_report_id = $('#saved_report_id').fieldValue();
	var report_id = $('#report_id').fieldValue();
	var fatal_err_str = 'It is not possible to schedule this report since some vital information is missing.';
	fatal_err_str += '\nThis is most likely a bug and should be reported to support@op5.com';

	var err_str = "";
	var errors = 0;
	if (interval[0] == '') {
		err_str += ' -Please select a schedule interval';
		errors++;
	}

	recipients = recipients.replace(/;/g, ',');
	$('#sched_recipients').fieldValue();
	// FIXME: split multiple addresses on ',' and check each one using regexp
	if (trim(recipients) == '') {
		err_str += ' -Please enter at least one recipient';
		errors++;
	}
	if (!saved_report_id[0]) {
		alert(fatal_err_str);
		return false;
	}
	if (interval[0]=='' || !interval[0]) {
		err_str += " -Please select interval";
		errors++;
	}

/*
	if (!report_name[0] || report_name[0] == '') {
		err_str += ' -Please enter a name for this report\n';
		errors++;
	} else {
		// all is ok
		show_request(formData, jqForm, options);
		return false;
	}
*/
	if (errors) {
		alert('Found the following error(s):\n' + err_str + '\nPlease correct this and try again');
		return false;
	}

    return true;
}

function trim(str, chars) {
	return ltrim(rtrim(str, chars), chars);
}

function ltrim(str, chars) {
	chars = chars || "\\s";
	return str.replace(new RegExp("^[" + chars + "]+", "g"), "");
}

function rtrim(str, chars) {
	chars = chars || "\\s";
	return str.replace(new RegExp("[" + chars + "]+$", "g"), "");
}

function remove_schedule(id)
{
	var message_div_start = '<div id="statusmsg"><img src="icons/16x16/sheild-ok.png" alt="OK" title="OK"> &nbsp;';
	var message_div_end = '</div>';
	var time = 3000;
	$('#response').remove();
	$('body').prepend('<div id="response"></div>');
	$('#response').css('background','#f4f4ed url(css/images/icons/32x32/shield-error.png) 7px 7px no-repeat').css("position", "relative").css('top', '0px').css('width','748px').css('left', '0px').css('padding','15px 2px 15px 50px ').html('Your schedule has been deleted.');
	nr_of_scheduled_instances--;
	// remove row for deleted ID
	$('#report-' + id).remove();
	if (nr_of_scheduled_instances == 0) {
		// last item deleted
		$('#schedule_report').hide(); // hide entire table/div
		$('#show_schedule').remove(); // remove 'View schedules' button
		$('#is_scheduled').remove();
		if ($('#avail_id') || $('#sla_id')) {
			var chk_text = '';
			chk_text = $('#avail_id option:selected').text();
			if (chk_text == '') {
				chk_text = $('#sla_id option:selected').text();
				chk_text = chk_text.replace(" ( *Scheduled* )", '');
				$('#sla_id option:selected').text(chk_text);
			} else {
				chk_text = chk_text.replace(" ( *Scheduled* )", '');
				$('#avail_id option:selected').text(chk_text);
			}
		}
		if (location.href.indexOf('avail_setup.php') == -1 && location.href.indexOf('/sla/index.php') == -1) { // they don't use thickbox
			tb_remove(); // close thickbox
		}
	}
	setTimeout('hide_message()', time);
}

function schedule_delete(id)
{
	if (!confirm('Do you really want to delete this schedule?\nThis action can\'t be undone.')) {
		return false;
	}
	var message_div_start = '<div id="statusmsg">';
	var message_div_end = '</div>';
	var time = 6000;
	// create ajax call to /monitor/op5/auto-reports/delete_schedule.php
	$.ajax({
		url:'/monitor/op5/auto-reports/delete_schedule.php?id=' + id,
		success: function(data) {
			if (data == 'OK') {
				// item deleted
				remove_schedule(id);
			} else {
				$('#response').css("position", "absolute").css('top', '11px').css('left', '200px').html(message_div_start + data + message_div_end);
				setTimeout('hide_message()', time);
			}
		}
	});
}

/**
*	create ajax call to /monitor/op5/auto-reports/fetch_field_value.php
*	to fetch a specific filed value and asssign it to html element.
*/
function fetch_field_value(type, id, elem_id)
{
	$.ajax({
		url:'/monitor/op5/auto-reports/fetch_field_value.php?id=' + id + '&type=' + type + '&elem_id=' + elem_id,
		success: function(data) {
			$('#' + elem_id).text(data);
		}
	});
}
