var startDate;
var endDate;
var DEBUG = false;
var host_tmp = host = service_tmp = service = false;
var current_obj_type = false; // keep track of what we are viewing
var is_populated = false; // flag list population when done

var sla_month_error_color    = 'red';
var sla_month_disabled_color = '#dcdcd7';
var sla_month_enabled_color  = 'white';
/**
*	store_start_date
*	Validate that start_time is BEFORE end_date
*	Called from end_time cal
*/
function store_start_date(cal) {
	cal.hide();
	startDate = new Date(cal.date);
	var now = new Date();
	if (endDate) {
		if (endDate <= startDate) {
			log('endDate <= startDate');
			alert("Please select a Start date BEFORE End date");
			document.forms['sla_form'].start_time.value='';
			document.getElementById('start_time_tmp').innerHTML = '';
			document.forms['sla_form'].start_time.focus();
			startDate = false;
			return false;
		}
	}
	if (startDate > now) {
		log('startDate > now!');
		alert("Please select a Start date in the past");
		document.forms['sla_form'].start_time.value='';
		document.getElementById('start_time_tmp').innerHTML = '';
		document.forms['sla_form'].start_time.focus();
		startDate = false;
		return false;
	}
}

/**
*	check_start_date
*	Validate that end_date is AFTER start_time
*	Called from end_time cal
*/
function check_start_date(cal) {
	cal.hide();
	endDate = new Date(cal.date);
	//endDate.setHours(0,0,0,0);
	log('EndDate: ' + endDate);

	if (startDate) {
		log('we HAVE startDate');
		//startDate.setHours(0,0,0,0);
		log('startDate: ' + startDate);
		if (startDate >= endDate) {
			log('startDate >= endDate');
			alert("Please select an End date AFTER Start date");
			document.forms['sla_form'].end_time.value='';
			document.getElementById('end_time_tmp').innerHTML = '';
			document.forms['sla_form'].end_time.focus();
			endDate = false;
			return false;
		}
	}
}

function show_calendar(val) {
	if (val=='custom') {
		document.getElementById("display").style.display='';
		document.forms['sla_form'].start_time.value='';
		document.forms['sla_form'].end_time.value='';
	} else {
		document.getElementById("display").style.display='none'
	}
	disable_sla_fields(val);
}

function disable_sla_fields(report_period)
{
	var now = new Date();
	var this_month = now.getMonth()+1;
	switch (report_period) {
		case 'thisyear':
			// weird as it seems, the following call actually ENABLES
			// all months. If not, we could end up with all months being
			// disabled for 'thisyear'
			disable_months(0, 12);
			for (i=this_month;i<=12;i++)
			{
				document.forms['sla_form'].elements['month_' + i].value='';
				document.forms['sla_form'].elements['month_' + i].disabled=true;
				document.forms['sla_form'].elements['month_' + i].style.backgroundColor=sla_month_disabled_color;
			}
			break;
		case 'custom':
			check_custom_months();
			break;
		case 'lastmonth':
			disable_last_months(1);
			break;
		case 'last3months':
			disable_last_months(3);
			break;
		case 'last6months':
			disable_last_months(6);
			break;
		case 'lastquarter':
			if(this_month <= 3){
				from = 10;
				to = 12;
			} else if (this_month <= 6) {
				from = 1;
				to = 3;
			} else if (this_month <= 9){
				from = 4;
				to = 6;
			} else {
				from = 7;
				to = 9;
			}
			disable_months(from, to);
			break;
		default:
			for (i=1;i<=12;i++)
			{
				document.forms['sla_form'].elements['month_' + i].disabled=false;
				document.forms['sla_form'].elements['month_' + i].style.backgroundColor=sla_month_enabled_color;
			}
	}
}

/**
 * Generic function to disable month_ fields
 * depending on if selection is last 1, 3 or 6 months.
 */
function disable_last_months(mnr)
{
	var now = new Date();
	var this_month = now.getMonth()+1;
	if (!mnr)
		return false;
	var from = (this_month-mnr);
	var to = (this_month-1);
	from = from<=0 ? (from + 12) : from;
	to = to<=0 ? (to + 12) : to;
	disable_months(from, to);
}

function show_state_options(val)
{
	if (eval(val)) {
		show_row('assumed_host_state');
		show_row('assumed_service_state');
	} else {
		hide_these = Array('assumed_host_state', 'assumed_service_state');
		hide_rows(hide_these);
	}
}
function edit_state_options(val)
{
	if (val) {
		show_row('assumed_host_state');
		show_row('assumed_service_state');
	} else {
		hide_these = Array('assumed_host_state', 'assumed_service_state');
		hide_rows(hide_these);
	}
}

function set_selection(val, no_erase) {
	// start by hiding ALL rows
	hide_these = Array('hostgroup_row', 'servicegroup_row', 'host_row_2', 'service_row_2', 'settings_table', 'submit_button'/*, 'assumed_host_state', 'assumed_service_state'*/, 'sla_setup', 'enter_sla');
	hide_rows(hide_these);
	show_progress('progress', 'Please wait...');
	switch (val) {
		case 'hostgroups':
			get_members('', 'hostgroup', no_erase);
			show_row('hostgroup_row');
			break;
		case 'servicegroups':
			get_members('', 'servicegroup', no_erase);
			show_row('servicegroup_row');
			break;
		case 'hosts':
			get_members('', 'host', no_erase);
			show_row('host_row_2');
			break;
		case 'services':
			get_members('', 'service', no_erase);
			show_row('service_row_2');
			break;
	}
	show_row('settings_table');
	show_row('sla_setup');
	show_row('enter_sla');
	show_row('submit_button');
}

// Restore has to work in both IE and FF...
var canSee = navigator.appName.indexOf("Microsoft") > -1 ? 'block' : 'table-row';

function hide_rows(input) {
	for (i=0;i<input.length;i++) {
		document.getElementById(input[i]).style.display='none';
	}
}

function get_members(val, type, no_erase) {
	if (type=='') return;
	is_populated = false;
	show_progress('progress', 'Please wait...');
	xajax_get_group_member(val, type, no_erase);
	sel_str = type;
	show_row('settings_table');
	show_row('submit_button');
}

function show_row(the_id) {
	document.getElementById(the_id).style.display = canSee;
}

function empty_list(field) {
	// escape nasty [ and ]
	field = field.replace('[', '\\[');
	field = field.replace(']', '\\]');

	// truncate select list
	$("#"+field).removeOption(/./);
}

function check_if_exist(field, val) {
	var field_name = field;
	log('Checking ' + field + ' Val: ' + val);
	field = document.forms['sla_form'].elements[field];
	if (! field)
		return false;
	for (i=field.length-1; i>=0; i--) {
		if (field.options[i].value == val) {
			log('Found item in list ' + field_name + ' that matches ' + val);
			return true;
		}
	}

	log('Found nothing in list ' + field_name + ' that matches ' + val);
	return false;
}

function add_if_not_exist(tmp_field, field, val) {
	tmp_f = tmp_field;
	if (!check_if_exist(field, val) && !check_if_exist(tmp_f, val)) {
		tmp_field = document.forms['sla_form'].elements[tmp_field];
		addOption(tmp_field, val, val, document.forms['sla_form'].elements[field]);
	}
}

/**
*	Populate HTML select list with supplied JSON data
*/
function populate_options(tmp_field, field, json_data)
{
	show_progress('progress', 'Please wait...');
	json_data = eval(json_data);
	for (var i = 0; i < json_data.length; i++) {
		addSelectOption(tmp_field, json_data[i].optionValue, json_data[i].optionValue, document.forms['sla_form'].elements[field]);
	}
	is_populated = true;
	setTimeout('delayed_hide_progress()', 1000);
}

// delay hiding of progress indicator
function delayed_hide_progress()
{
	setup_hide_content('progress');
}

function addSelectOption(theSel, theText, theValue, theSelFrom)
{
	theSel = theSel.replace('[', '\\[');
	theSel = theSel.replace(']', '\\]');
	$("#"+theSel).addOption(theValue, theText, false);
}

function sla_addOption(field, val, txt)
{
	log('called addOption with field:' + field + ' values: ' + val + ',' + + txt);
	field = document.forms['sla_form'].elements[field];
	addOption(field, val, txt);
}
function log(msg) {
	if (DEBUG) {
		console.log(msg);
	}
}

function setup_hide_content(d) {
	if(d.length < 1) {
		return;
	}
	$('#' + d).hide();
}

function toggle_label_weight(val, the_id)
{
	if (document.getElementById(the_id)) {
		elem = document.getElementById(the_id);
		elem.style.fontWeight = val ? 'bold' : '';
	}
}

function set_initial_state(what, val)
{
	f = document.forms['sla_form'];
	var item = '';
	var elem = false;
	switch (what) {
		case 'host':
			item = 'initialassumedhoststate';
			break;
		case 'service':
			item = 'initialassumedservicestate';
			break;
		case 'includesoftstates':
			if (val!='0') {
				toggle_label_weight(1, 'include_softstates');
				f.elements['includesoftstates'].checked = true;
				log('Setting includesoftstates');
			} else {
				toggle_label_weight(0, 'include_softstates');
				f.elements['includesoftstates'].checked = false;
			}
			break;
		case 'assumeinitialstates':
			show_state_options(val);
			if (val!='0') {
				edit_state_options(1);
				toggle_label_weight(1, 'assume_initial');
				f.elements['assumeinitialstates'].checked = true;
			} else {
				f.elements['assumeinitialstates'].checked = false;
				toggle_label_weight(0, 'assume_initial');
			}
			break;
		case 'scheduleddowntimeasuptime':
			if (val!='0') {
				toggle_label_weight(1, 'sched_downt');
				f.elements['scheduleddowntimeasuptime'].checked = true;
			} else {
				f.elements['scheduleddowntimeasuptime'].checked = false;
				toggle_label_weight(0, 'sched_downt');
			}
			break;
		case 'sla_name':
			f.elements['sla_name'].value = val;
			break;
		case 'rpttimeperiod':
			// f.elements['rpttimeperiod'].value = val;
			item = 'rpttimeperiod';
			break;
		case 'report_period-start':
			item = 'start_year';
			break;
		case 'report_period-startmonth':
			item = 'start_month';
			break;
		case 'report_period-end':
			item = 'end_year';
			break;
		case 'report_period-endmonth':
			item = 'end_month';
			break;
		default:
			item = what;
	}
	if (item) {
		elem = f.elements[item];
		for (i=0;i<elem.length;i++) {
			if (elem.options[i].value==val) {
				elem.options[i].selected = true;
			}
		}
	}
}

/**
*	Receive params as JSON object
*	Parse fields and populate corresponding fields in form
*	with values.
*/
function expand_and_populate(data)
{
	var slaObj = data;
	var field_obj = new field_maps();
	var field_str = slaObj['report_type'];
	str  = "";
	if (slaObj['objects']) {
		for (prop in slaObj['objects']) {
			//str += prop + ": " + slaObj['objects'][prop] + "\n";
			add_if_not_exist(field_obj.map[field_str]+'[]',
				field_obj.map[field_str]+'_tmp[]', slaObj['objects'][prop]);
		}
	}

	// set selected object type in object drop-down and
	// prevent the right box to be cleared
	set_selection(slaObj['report_type'], 'true');

	set_initial_state('assumeinitialstates', slaObj['assumeinitialstates']);
	set_initial_state('host', slaObj['initialassumedhoststate']);
	set_initial_state('service', slaObj['initialassumedservicestate']);
	set_initial_state('scheduleddowntimeasuptime', slaObj['scheduleddowntimeasuptime']);
	set_initial_state('report_type', slaObj['report_type']);
	set_initial_state('report_period', slaObj['report_period']);
	show_calendar(slaObj['report_period']);
	set_initial_state('rpttimeperiod', slaObj['rpttimeperiod']);
	set_initial_state('sla_name', slaObj['sla_name']);
	set_initial_state('includesoftstates', slaObj['includesoftstates']);
	if (slaObj['report_period'] == 'custom' && slaObj['start_time']!='' && slaObj['end_time']) {
		// Custom report periods are treated somewhat special
		// start- and end-time needs to be converted to date object
		// and we need to wait for ajax call to populate the select boxes
		setTimeout('set_initial_state("report_period-start", ' + epoch_to_human(slaObj['start_time'], 'year') + ')', 1000);
		setTimeout('set_initial_state("report_period-startmonth", ' + epoch_to_human(slaObj['start_time'], 'month') + ')', 1000);
		setTimeout('set_initial_state("report_period-end", ' + epoch_to_human(slaObj['end_time']-86400, 'year') + ')', 1000);
		setTimeout('set_initial_state("report_period-endmonth", ' + epoch_to_human(slaObj['end_time']-86400, 'month') + ')', 1000);
		js_print_date_ranges(slaObj['start_time'], 'start', 'month');
		js_print_date_ranges(slaObj['end_time'], 'end', 'month');
	}
	current_obj_type = field_str;

	// wait for lists to populate
	setTimeout("remove_duplicates();", 500);
}

/**
*	Remove duplicate entries
*	We need to check that we don't have items in the
*	left (available) list that is added to the to the right (selected)
'	Also, we need to check that the right list doesn't have items that are
*	removed from the configuration.
*/
function remove_duplicates()
{
	if (!current_obj_type) {
		return false;
	}
	if (!is_populated) {
		// check if lists has been populated before trying
		// to remove duplicates and removed objects.
		// Call self if not ready yet
		setTimeout("remove_duplicates();", 500);
		return false;
	}
	setup_hide_content('progress');
	var field_obj = new field_maps();
	var tmp_fields = new field_maps3();
	var field_str = current_obj_type;
	var field = field_obj.map[field_str]+'[]'
	var tmp_field = tmp_fields.map[field_str]+ '[]';
	var removed_items = new Array();
	var i = 0;

	$("select[name='" + field + "'] option").each(function() {
		var this_item = $(this).val();
		if ($("select[name='" + tmp_field + "']").containsOption(this_item)) {
			$("select[name='" + tmp_field + "']").removeOption($(this).val());
		} else {
			$("select[name='" + field + "']").removeOption(this_item);
			removed_items[i++] = this_item;
		}
	});
	if (removed_items.length) {
		var info_str = "Some items in your saved report doesn't exist anymore and has been removed: ";
		info_str += "<ul><li><img src=\"../css/images/arrow.gif\" /> " + removed_items.join('</li><li><img src="../css/images/arrow.gif" /> ') + '</li></ul>';
		info_str += 'Please modify the objects to include in your report below and then save it.';
		info_str += '<a href="#" onclick="hideMe(\'response\')" style="position:absolute;top:8px;left:700px;">Close <img src="../css/images/icons/cross_12x12.gif" /></a>';
		$('#response')
			.css('background','#f4f4ed url(../css/images/icons/32x32/shield-info.png) 7px 7px no-repeat')
			.css("position", "relative")
			.css('top', '0px')
			.css('width','748px')
			.css('left', '0px')
			.css('padding','15px 2px 15px 50px ')
			.html(info_str);
	}
}

function hideMe(elem)
{
	$('#' + elem).hide('slow');
}

function epoch_to_human(val, what){
	var datum = new Date(val * 1000);
	//document.getElementById('result1').innerHTML = "<b>GMT</b>: "+datum.toGMTString()+"<br><b>Your timezone</b>: "+datum.toLocaleString();
	if (what == 'year') {
		return datum.getFullYear();
	} else {
		return datum.getMonth() + 1;
	}
}

function field_maps()
{
	this.map = new Object();
	this.map['hosts']="host_name";
	this.map['services']="service_description";
	this.map['hostgroups']="hostgroup";
	this.map['servicegroups']="servicegroup";
}

function field_maps3()
{
	this.map = new Object();
	this.map['hosts']="host_tmp";
	this.map['services']="service_tmp";
	this.map['hostgroups']="hostgroup_tmp";
	this.map['servicegroups']="servicegroup_tmp";
}

function check_and_submit(f)
{
	if (f.sla_id.value!="") {
		f.submit();
		return true;
	} else {
		$('#is_scheduled').text('');
	}
	return false;
}

function confirm_delete_sla(the_val, the_path, is_scheduled)
{
	var msg = "Are you really sure that you would like to remove this saved SLA report?";
	if (the_val!="" && the_path!="") {
		if (is_scheduled=='true') {
			msg += "\n\nPlease note that this is a scheduled report and if you decide to delete it, \n";
			msg += "the corresponding schedule will be deleted as well.\n\n";
			msg += "Are you really sure that this is what you want?";
		}

		if (confirm(msg)) {
			self.location.href=the_path + '?del_sla=true&del_id=' + the_val;
			return true;
		}
	}
	return false;
}

function toggle_field_visibility(val, theId) {
	if (val) {
		document.getElementById(theId).style.display='block';
	} else {
		document.getElementById(theId).style.display='none';
	}
}

/**
*	Uncheck form element by name
*	Used to set correct initial values
*	since some browser seem to cache checkbox state
*/
function uncheck(the_name, form_name)
{
	document.forms[form_name].elements[the_name].checked=false;
}
/**
*	Validate form values before submit
*/
function check_form_values(f)
{
	var max_val = 100;
	var errors = 0;
	var err_str = '';
	var nr_of_slas = 0;

	// start by checking and setting start- and end_time values
	if (f.report_period.value == 'custom') {
		var start_year = f.start_year ? f.start_year.value : false;
		var start_month = f.start_month ? f.start_month.value : false;

		var end_year = f.end_year ? f.end_year.value : false;
		var end_month = f.end_month ? f.end_month.value : false;
		if (!start_year || !start_month || !end_year || !end_month) {
			err_str = '<li>Please select start and end date values</li>';
			errors++;
		} else {
			// add leading 0 for months < 10
			start_month = start_month.length<2 ? '0' + start_month : start_month;
			// set start- and end_time fields
			// new Date(year, month, day, hours, minutes, seconds, milliseconds)
			startDate = new Date(start_year, start_month, 1);
			startDate.setMonth(startDate.getMonth()-1);
			f.start_time.value 	= start_year + '-' + start_month + '-01 00:00';
			var end_time_obj 	= new Date(end_year, (end_month-1), '01', '0', '1');
			end_time_obj.setMonth(end_time_obj.getMonth() + 1);
			var DD = end_time_obj.getDate();
			DD = DD<10 ? '0' + DD : DD; // add leading 0 for dates<10
			var MM = end_time_obj.getMonth()+1;
			MM = MM<10 ? '0' + MM : MM; // add leading 0 for months<10
			var YY = end_time_obj.getFullYear();
			endDate = end_time_obj;
			f.end_time.value = YY + '-' + MM + "-" + DD + " 00:00";
			if (startDate > endDate) {
				err_str += '<li>Please select a start date BEFORE end date</li>';
				errors++;
			} else {
				var nr_of_months = check_date_length();
				if (nr_of_months !== true) {
					err_str += '<li>You have entered a reporting period exceeding > 12 months (' + nr_of_months + ').</li>';
					errors++;
				}
			}
		}
	}
	var sla_outside = is_not_valid_sla_date_range();
	if (sla_outside>0) {
		err_str += '<li>You have entered SLA value(s) outside date range.</li>';
		errors++;
	}

	if (f.elements['report_period'].value=='') {
		err_str += '<li>Please select a valid reporting period</li>';
		errors++;
	}

	// check for sane SLA values
	var red_error = false;
	for (i=1;i<=12;i++) {
		var field_name = 'month_' + i;
		var value = f.elements[field_name].value;
		value = value.replace(',', '.');
		if (value > max_val || isNaN(value)) {
			f.elements[field_name].style.background = sla_month_error_color;
			errors++;
			red_error = true;
		} else {
			if (value != '') {
				nr_of_slas++;
			}
			if(f.elements[field_name].disabled)
				f.elements[field_name].style.background = sla_month_disabled_color;
			else
				f.elements[field_name].style.background = sla_month_enabled_color;
		}
	}
	if (red_error) {
		err_str += '<li>Please check SLA values in fields marked red below and try again</li>';
	}

	if (nr_of_slas == 0) {
		errors++;
		err_str += "<li>Please enter at least one SLA value</li>";
	}

	if(f.elements['sla_name'].value == '' && f.elements['save_sla_settings'].checked == true ) {
		errors++;
		err_str += '<li>Please enter a name for you SLA</li>';
	}

	// make sure user selected objects to create report on:
	// hosts/services/hostgroup/servicegroup
	var field_obj = new field_maps();
	var rpt_type = f.report_type.value;
	if (f.elements[field_obj.map[rpt_type] + '[]'].length == 0) {
		errors++;
		err_str += "<li>Please select what objects to base the report on from the left <br />";
		err_str += " checkbox above by moving them to the right checkbox</li>";
	}

	if(typeof window.jQuery != "undefined") {
		var sla_name 		= $("input[name=sla_name]").val();
		var saved_sla_id 	= $("input[name=saved_sla_id]").val();
		var do_save_sla = $('input[name=save_sla_settings]').attr('checked') ? 1 : 0;

		/*
		*	Only perform checks if:
		*		- Saved SLAs exists
		*		- User checked the 'Save SLA' checkbox
		*		- We are currently editing a SLA (i.e. have saved_sla_id)
		*/
		if ($('#sla_id') && do_save_sla && saved_sla_id) {
			// Saved SLA reports exists
			$('#sla_id option').each(function(i) {
				if ($(this).val()) {// first item is empty
					if (saved_sla_id != $(this).val()) {
						// check all the other saved SLAs
						// make sure we don't miss the scheduled reports
						var chk_text = $(this).text();
						chk_text = chk_text.replace(" ( *Scheduled* )", '');
						if (sla_name == chk_text) {
							// trying to save an item with an existing name
							errors++;
							err_str += "<li>You have entered a name for your SLA that already exists. <br />Please select a new name.</li>";
							return false;
						}
					}
				}
			});
		}
	}

	// display err_str if any
	if (!errors) {
		document.getElementById('response').innerHTML = '';

		// check if sla name is unique
		if(saved_sla_id == '' && invalid_sla_info_names && invalid_sla_info_names.indexOf(sla_name) != -1)
		{
			if(!confirm("The entered name already exists. Press 'Ok' to replace the entry with this name"))
			{
				return false;
			}
		}
		return true;
	}

//	document.getElementById('response').innerHTML = "<ul class=\"error\">" + err_str; + "</ul>"
	// clear all style info from progress
	$('#response').attr("style", "");
	$('#response').html("<ul class=\"error\">" + err_str + "</ul>");

	window.scrollTo(0,0); // make sure user sees the error message
	// stop form from submtting
	return false;
}

/**
*	Ensure that an existing SLA report isn't trying to
*	use an already existing (saved) name.
*/
function check_report_update(f)
{
	var report_name 	= f.sla_name.value;
	var saved_sla_id 	= f.sla_id.value;
	var old_report_name = f.old_report_name.value;

	if (report_name.replace(/ /, '') == '') {
		alert('Please give your report a meaningful name.');
		return false;
	}
	if (invalid_sla_info_names && invalid_sla_info_names.indexOf(report_name) != -1) {
		if (saved_sla_id == '' || !saved_sla_id) {
			if (!confirm("The entered name already exists. Press 'Ok' to replace the entry with this name")) {
				return false;
			}
		} else {
			if (report_name!=old_report_name) {
				alert("You have entered a name for your report that already exists.\nPlease select a new name.");
				return false;
			}
		}
	}
	return true;
}

function handle_autofill(f)
{
	var the_val = false;
	var the_form = document.forms['sla_form'];
	if (the_form.elements[f].value!='') {
		the_val = the_form.elements[f].value;
		if (!confirm("Would you like to propagate this value to all months")) {
			return false;
		}
		set_sla_form_values(the_form, the_val);
	} else {
		if (!confirm("Would you like to remove all values from all months")) {
			return false;
		}
		set_sla_form_values(the_form, '');
	}
}

function set_sla_form_values(the_form, the_val)
{
	for (i=1;i<=12;i++) {
		var field_name = 'month_' + i;
		if(the_form.elements[field_name].disabled)
			the_form.elements[field_name].value = '';
		else
			the_form.elements[field_name].value = the_val;
	}

}

function check_sla_form_values(the_form, max_month)
{
	var errors = false;
	for (i=1;i<=12;i++) {
		var field_name = 'month_' + i;
		month_val = the_form.elements[field_name].value;
		if (month_val!='' && i>max_month) {
			errors++;
		}
	}
	return errors;
}

/**
*	Check that date range and sla data is OK
*/
function is_not_valid_sla_date_range()
{
	var the_form = document.forms['sla_form'];
	report_period = the_form.report_period.value;
	var curdate = new Date();
	var curmonth = curdate.getMonth(); // 0=jan, 11=dec
	var sla_ok = false;
	if (report_period == 'thisyear') {
		sla_ok = check_sla_form_values(the_form, curmonth);
	}
	return sla_ok;
}

function check_date_length()
{
	var nr_of_months = Math.floor((endDate - startDate)/(1000*60*60*24*30));
	if (nr_of_months > 12) {
		return nr_of_months;
	}
	return true;
}

function js_print_date_ranges(the_year, type, item)
{
	show_progress('progress', 'Please wait...');
	xajax_print_date_ranges(the_year, type, item);
	setTimeout('check_custom_months()', 1000);
}

function check_custom_months()
{
	var f		 	= document.forms['sla_form'];
	var start_year 	= f.start_year.value;
	var start_month = f.start_month.value;
	var end_year 	= f.end_year.value;
	var end_month 	= f.end_month.value;
	if (start_year!='' && end_year!='' && start_month!='' && end_month!='') {
		if (start_year < end_year) {
			// start and end months will have to "restart"
			disable_months(start_month, end_month);
		} else {
			if (start_year < end_year || start_year == end_year) {
				// simple case - disable from start_month to end_month
				disable_months(start_month, end_month);
			} else {
				// start_year > end_year = ERROR
				// handled by check_form_values but let's disable all months?
				disable_months(0, 0);
			}
		}
	}
	setup_hide_content('progress');
}

function disable_months(start, end)
{
	var disabled_state 		= false;
	var not_disabled_state 	= false;
	var col 				= false;
	start 	= eval(start);
	end 	= eval(end);
	for (i=1;i<=12;i++) {
		if (start>end) {
			if ( i >= start || i <= end) {
				disabled_state = false;
				col = sla_month_enabled_color;
			} else {
				document.forms['sla_form'].elements['month_' + i].value='';
				disabled_state = true;
				col = sla_month_disabled_color;
			}
		} else {
			if ( i>= start && i <= end) {
				disabled_state = false;
				col = sla_month_enabled_color;
			} else {
				document.forms['sla_form'].elements['month_' + i].value='';
				disabled_state = true;
				col = sla_month_disabled_color;
			}
		}
		document.forms['sla_form'].elements['month_' + i].disabled=disabled_state;
		document.forms['sla_form'].elements['month_' + i].style.backgroundColor=col;
	}
}

var is_visible = false;
function toggle_edit() {
	if (is_visible) {
		$("#schedule_report").hide();
		$("#show_scheduled").text('[edit]');
		is_visible = false;
	} else {
		$('#schedule_report').show();
		$("#show_scheduled").text('[hide]');
		is_visible = true;
	}
}

function setup_editable()
{
	$(".iseditable").editable("/monitor/op5/auto-reports/save_item.php", {
		id   : 'elementid',
		name : 'newvalue',
		type : 'text',
		event : 'dblclick',
		width : 'auto',
		height : '14px',
		submit : 'OK',
		cancel : 'cancel',
		placeholder:'Double-click to edit'
	});
	$(".period_select").editable("/monitor/op5/auto-reports/save_item.php", {
		data : $('#autoreport_periods').text(),
		id   : 'elementid',
		name : 'newvalue',
		event : 'dblclick',
		type : 'select',
		submit : 'OK',
		cancel : 'cancel'
	});
	$(".iseditable_txtarea").editable("/monitor/op5/auto-reports/save_item.php", {
		indicator : "<img src='icons/arrows/indicator.gif'>",
		id   : 'elementid',
		name : 'newvalue',
		type : 'textarea',
		event : 'dblclick',
		rows: '3',
		submit : 'OK',
		cancel : 'cancel',
		cssclass: "txtarea",
		placeholder:'Double-click to edit'
	});
}

if(typeof window.jQuery != "undefined") {
	$(document).ready(function(){
		setup_editable();
		$("#show_scheduled").click(function(){toggle_edit()});
	});
}
