<?php
if (!isset($test))
	$test = array();
if (!isset($correct))
	$correct = array();
if (!isset($showlog))
	$showlog = "/opt/monitor/op5/reports/module/showlog";

if (PHP_SAPI !== 'cli') {
	header("Content-disposition: attachment; filename=report-test.txt");
	header("Content-type: text");

	if (!isset($_REQUEST['test'])) {
		die("No test data to produce test-case from");
	}
	$test = $_REQUEST['test'];
	if (isset($_REQUEST['correct']))
		$correct = $_REQUEST['correct'];
} else {
	if ($argc < 3)
		die("\nusage: mktest.php <db_start_time=timestamp> <db_end_time=timestamp> <options>\n\n");
	for ($i = 1; $i < $argc; $i++) {
		if (strpos($argv[$i], '=') === false)
			die("Malformed argument: $argv[$i]\n");
		$ary = explode('=', $argv[$i], 2);
		$k = $ary[0]; $v = $ary[1];
		$ary = split("[\t ]*,[\t ]*", $v);

		if (count($ary) > 1) {
			$v = $ary;
			$test[$k] = $ary;
			continue;
		}
		if (isset($test[$k])) {
			if (!is_array($test[$k])) {
				$test[$k] = array($test[$k]);
			}
			if (is_array($v)) {
				foreach ($v as $item)
					$test[$k][] = $item;
			} else {
				$test[$k][] = $v;
			}
		} else {
			$test[$k] = $v;
		}
	}
}

if (!isset($test['db_start_time']) && isset($test['start_time']))
	$test['db_start_time'] = $test['start_time'];
if (!isset($test['db_end_time']) && isset($test['end_time']))
	$test['db_end_time'] = $test['end_time'];
if (!isset($test['start_time']) && isset($test['db_start_time']))
	$test['start_time'] = $test['db_start_time'];
if (!isset($test['end_time']) && isset($test['db_end_time']))
	$test['end_time'] = $test['db_start_time'];

if (!isset($test['db_start_time']))
	die("No db_start_time defined\n");
if (!isset($test['db_end_time']))
	die("No db_end_time defined\n");

$db_start_time = $test['db_start_time'];
$db_end_time = $test['db_end_time'];
unset($test['db_start_time']);
unset($test['db_end_time']);
$showlog .= " --first=$db_start_time --last=$db_end_time";

/**
 * Fetch and print the SQL insert statements we need to run to duplicate
 * the data-set the report used to generate its data.
 */
$obj_type = $objects = false;
function print_db_lines($prefix, $table = 'report_data')
{
	global $test, $db_start_time, $db_end_time;

	require_once(dirname(__FILE__) . '/sql_class.php');

	$sql_class = new sql_class;
	$dba = $sql_class->db;
	if (!$dba) {
		die("Database connection failed\n");
	}

	$start = $db_start_time;
	$stop = $db_end_time;
	$query = "SELECT * FROM $table " .
		"WHERE timestamp >= $db_start_time AND timestamp <= $db_end_time ";

	if (!empty($test['service_description'])) {
		$ignore_event = 801;
		$objects = $test['service_description'];
		$otype = 'concat(host_name, ";", service_description)';
		$obj_type = 'service';
		if (!is_array($objects))
			$objects = array($objects);
		$objects[] = ';';
	} else {
		$ignore_event = 701;
		$objects = $test['host_name'];
		$obj_type = 'host';
		$otype = 'host_name';
		if (!is_array($objects))
			$objects = array($objects);
		$objects[] = '';
	}
	$query .= "AND event_type != $ignore_event " .
		"AND $otype IN ('" . join("', '", $objects) . "') ";
	echo "# sql query: $query\n";
	$res = $dba->execute($query);
	if (empty($res))
		return;

	echo "\tsql {\n";
	foreach ($res as $row) {
		unset($row['id']);
		echo "\t\tINSERT INTO $table(" . join(',', array_keys($row)) . ')';
		echo " VALUES(";
		$first = true;
		foreach ($row as $v) {
			if (!$first)
				echo ",";
			else
				$first = false;
			echo "'" . mysql_real_escape_string($v) . "'";
		}
		echo ");\n";
	}
	echo "\t}\n";
}

function print_test_settings()
{
	global $test;

	# report uses lib_reports default settings
	if (!isset($test['start_time']) || !isset($test['end_time'])) {
		echo "Empty report settings. We need start_time and end_time\n";
		print_r($test);
		exit(1);
	}

	foreach ($test as $k => $v) {
		if (is_array($v) && count($v) === 1)
			$v = array_pop($v);

		if (is_array($v)) {
			echo "\t$k {\n";
			foreach ($v as $v2) {
				echo "\t\t$v2\n";
			}
			echo "\t}\n";
			continue;
		}
		echo "\t$k = $v\n";
	}
}

function print_log_lines()
{
	global $showlog, $test;

	$cmd = "$showlog --time-format=raw";
	$cmd . " /opt/monitor/var/nagios.log";
	$cmd .= " /opt/monitor/var/archives/*.log";

	$retcode = 0;
	if (!empty($test['host_name'])) {
		if (!is_array($test['host_name']))
			$cmd .= " --host='$test[host_name]'";
		else
			$cmd .= " --host='" . join("' --host='", $test['host_name']) . "'";
	}
	if (!empty($test['host_name']) && !empty($test['service_description']))
		$cmd .= " --service='$test[host_name];$test[service_description]'";

	if (!empty($test['service_description']))
		$cmd .= ' --service-states=a';

	echo "\t# showlog command: $cmd\n";
	echo "\tlog {\n";
	passthru($cmd, $retcode);
	echo "\t}\n\n";
}

function print_test($desc)
{
	echo "$desc {\n";
	print_test_settings();
	print_db_lines("\t\t");
	print_log_lines();
	echo "}\n";
}

print_test("auto-created test");
