# This test-series serves as a README for how to write tests,
# as well as providing a series of tests to run against the
# logfiles from the op5 demo system (which used to be our
# production system).
#
# As such, it's heavily commented even for fairly basic
# key/value pairs.


# A description of the test-case
description = Tests against op5 logfiles

# The "logfiles" compound tells which logfiles we should load into
# the database. They aren't required, but unless they are, all values
# will be TIME_UNDETERMINED_NO_DATA
logfiles {
	test-op5/*.log
	nisse = testing
	block2 {
		testing testing
	}
}

# a gzipped tarball to extract in the /opt/monitor directory
config_files = etc.op5.tar.gz

# This is a test named "basic math test"
# Inside the compound, the various test parameters are declared
basic math test {
	# These parameters are probably self-explanatory
	start_time = 1201533591
	end_time = 1201447191
	hostname = linux-server1
	service = PING

	# Only the things listed here are tested. We will get more
	# values back, but they can be ignored for the sake of
	# testing something specifically
	correct {
		TIME_WARNING = 10000;
		TIME_OK = 16400;
		TIME_CRITICAL = 50000;
		TIME_UNDETERMINED_NOT_RUNNING = 10000;
	}
}

scheduled downtime as uptime {
	hostname = sdfsdf
	service = PING
	start_time = 11500000;
	end_time = 11123312;

	correct {
		STATE_OK = 234893
		STATE_WARNING = 234982
	}
}
