<?php
	header('Cache-Control: no-cache, no-store, max-age=0, must-revalidate');
	header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
	header('Pragma: no-cache');
	require_once('../paths.inc.php');
	require_once($op5common_path."/lib/xajax/xajax_core/xajax.inc.php");
	require_once($op5common_path."/lib/json_class.php");
	require_once('../lib_reports.php');
	require_once('../lib_gui.php');
	require_once('lib_sla.php');
	require_once('../default_settings.php');
	require_once('../auth.php');
	$mon_auth = new monitor_auth_class(get_array_var($_SERVER, 'REMOTE_USER'));

	$del_id 	= get_array_var($_REQUEST, 'del_id');
	$del_ok 	= '';
	$del_msg 	= '';
	if (get_array_var($_REQUEST, 'del_sla') !== false && $del_id !== false) {
		$del_ok = delete_sla($del_id);
		if ($del_ok != '') {
			$del_msg = "OK, SLA report deleted successfully";
		} else {
			$del_msg = "An error occurred when trying to delete the SLA report";
		}
	}

	//get_hostgroup_members
	$xajax = new xajax();
	$filters = 1;

	$xajax->registerFunction('get_group_member');
	$xajax->registerFunction('print_date_ranges');
	$xajax->registerFunction('fetch_scheduled_field_value');
	$xajax->processRequest();

	$initial_assumed_host_states = array
	(
	   -1 => 'Current state',
	   -2 => 'Unspecified',
	   -3 => 'First Real State',
	    0 => 'Host Up',
	    1 => 'Host Down',
	    2 => 'Host Unreachable',
	);

	$initial_assumed_service_states = array
	(
	   -1 => 'Current state',
	   -2 => 'Unspecified',
	   -3 => 'First Real State',
	    0 => 'Service Ok',
	    1 => 'Service Warning',
	    2 => 'Service Critical',
	    3 => 'Service Unknown',
	);

	$old_config_names = get_all_sla_config_names();
	$old_config_names_js = empty($old_config_names) ? "false" : "new Array('".implode("', '", $old_config_names)."');";

	$assume_states_during_not_running_checked = get_array_var($_REQUEST, 'assumestatesduringnotrunning', $default_assume_states_during_not_running) ? 'checked="checked"' : '';
	$include_soft_states_checked              = 'checked="checked"';
	$scheduled_downtime_as_uptime_checked     = get_array_var($_REQUEST, 'scheduleddowntimeasuptime',    $default_scheduled_downtime_as_uptime) ? 'checked="checked"' : '';
	$assume_initial_states_checked            = get_array_var($_REQUEST, 'assumeinitialstates',          $default_assume_initial_states) ? 'checked="checked"' : '';
	$initial_assumed_host_state_selected      = get_array_var($_REQUEST, 'initialassumedhoststate',      $default_initial_assumed_host_state);
	$initial_assumed_service_state_selected   = get_array_var($_REQUEST, 'initialassumedservicestate',   $default_initial_assumed_service_state);
    $keep_logs_checked                        = get_array_var($_REQUEST, 'keep_logs',                    $default_keep_logs) ? 'checked="checked"' : '';
	$keep_logs_maxrows                        = (int)get_array_var($_REQUEST, 'keep_logs_maxrows',            $default_keep_logs_maxrows);
    $keep_logs_states_masks = array();
	$keep_logs_states_masks = get_array_var($_REQUEST, 'keep_logs_states', mask_to_state_masks((int)$default_keep_logs_states_mask));
	$use_alias  = get_array_var($_REQUEST, 'use_alias', $default_use_alias);

	$use_average_yes_selected = $use_average_no_selected = '';

	if(get_array_var($_REQUEST, 'use_average', $default_use_average) == 1)
		$use_average_yes_selected = 'selected="selected"';
	else
		$use_average_no_selected = 'selected="selected"';

	$use_alias_checked = $use_alias ? 'checked="checked"' : '';
	$saved_sla = false;#get_saved_slas();
	$sla_id = false;
	$sla_info = false;
	$is_scheduled = false;
	$scheduled_info = false;
	$scheduled_ids = array();
	$scheduled_periods = false;
	// =========== Fetch info on saved SLA ===========
	if (get_array_var($_REQUEST, 'sla_id'))
	{
		$sla_id = (int)get_array_var($_REQUEST, 'sla_id');
		$sla_info = get_sla_info($sla_id);
		$scheduled_info = report_is_scheduled($sla_id, 'sla');
		$is_scheduled = empty($scheduled_info) ? false: true;

		if(isset($sla_info['assume_initial_states']) && $sla_info['assume_initial_states'] != 0)
			$assume_initial_states_checked = "checked='checked'";
		else
			$assume_initial_states_checked = '';

		if($sla_info['initialassumedhoststate'] != 0)
			$initial_assumed_host_state_selected = "checked='checked'";
		else
			$initial_assumed_host_state_selected = '';

		if($sla_info['initialassumedservicestate'] != 0)
			$initial_assumed_service_state_selected = "checked='checked'";
		else
			$initial_assumed_service_state_selected = '';

		if($sla_info['assumestatesduringnotrunning'] != 0)
			$assume_states_during_not_running_checked = "checked='checked'";
		else
			$assume_states_during_not_running_checked = '';

		if($sla_info['includesoftstates'] != 0)
			$include_soft_states_checked = "checked='checked'";
		else
			$include_soft_states_checked = '';

		if(isset($sla_info['use_average']) && $sla_info['use_average'] != 0)
		{
			$use_average_no_selected = '';
			$use_average_yes_selected = "selected='selected'";
		}
		else
		{
			$use_average_no_selected = "selected='selected'";
			$use_average_yes_selected = '';
		}

		$use_alias_checked = (isset($sla_info['use_alias']) && $sla_info['use_alias'] != 0) ? 'checked="checked"' : '';

		$keep_logs_checked = (isset($sla_info['keep_logs']) && $sla_info['keep_logs'] != 0) ? 'checked="checked"' : '';
		$keep_logs_maxrows = (isset($sla_info['keep_logs_maxrows'])) ? (int) $sla_info['keep_logs_maxrows'] : 0;
		$keep_logs_states_masks = array();
		if (isset($sla_info['keep_logs_states_mask'])) {
			$keep_logs_states_masks = mask_to_state_masks((int)$sla_info['keep_logs_states_mask']);
		}

		if(isset($sla_info['scheduledowntimeasuptime']) && $sla_info['scheduledowntimeasuptime'] != 0)
			$scheduled_downtime_as_uptime_checked = "checked='checked'";
		else
			$scheduled_downtime_as_uptime_checked = '';

		$report_period = $sla_info['report_period'];
	}
	$scheduled_reports = get_scheduled_reports('sla');
	foreach ($scheduled_reports as $scheduled_row) {
		$scheduled_ids[] = $scheduled_row['report_id'];
		$scheduled_periods[$scheduled_row['report_id']] = $scheduled_row['periodname'];
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
		<meta http-equiv="Content-type" content="application/xhtml+xml; charset=iso-8859-1" />
		<title> op5 Monitor &raquo; SLA Setup</title>
		<link type="text/css" rel="stylesheet" href="../css/new.css" />
		<link type="text/css" rel="stylesheet" href="../css/colours.css" />
		<link type="text/css" rel="stylesheet" href="../css/help.css" />
		<link type="text/css" rel="stylesheet" href="../css/response.css" />
		<script type="text/javascript" src="../js/common.js"></script>
		<script type="text/javascript" src="../js/move_options.js"></script>
		<script type="text/javascript" src="../js/filterlist.js"></script>
		<script type="text/javascript" src="../js/jquery.js"></script>
		<script type="text/javascript" src="../js/jquery.jeditable.mini.js"></script>
		<script type="text/javascript" src="../js/jquery.selectboxes.js"></script>
		<script type="text/javascript" src="../js/sla.js"></script>
		<script type="text/javascript" src="../js/help.js"></script>
		<script type="text/javascript" src="../js/helptexts.js"></script>
		<script type="text/javascript" src="../js/schedule_report.js"></script>
		<script type="text/javascript" src="../js/reports.js"></script>
	<?php $xajax->printJavascript('/op5common/lib/xajax/');

	// =========== Check if we should delete a saved SLA ========
	if (!empty($del_msg)) {
		// print return message to user about requested deletion
		?>
		<script type="text/javascript">
		<!--
			function hide_message()	{
				document.getElementById('response').style.display='none';
			}

			function show_message()	{
				document.getElementById('response').style.display='';
				document.getElementById('response').style.margin='0px 0px 7px 0px';
				document.getElementById('response').innerHTML='<ul class="<?php echo $type; ?>"><?php echo $del_msg ?></ul>';
				setTimeout('hide_message()', 5000);
			}
		//-->
		</script>
	</head>
	<body onload="show_message();"><?php
	} else {?>
	</head>
	<body><?php
	}

	?>
		<div id="help"></div>
		<div id="response"></div>

			<?php if ($saved_sla) { ?>
			<div class="setup-table" style="margin-bottom: 7px">
					<form name="saved_sla_form" id="saved_sla_form" method="post" action="<?php echo $_SERVER['PHP_SELF'] ?>" onsubmit="return check_and_submit(this)">
					<div>

						<select name="sla_id" id="sla_id" onchange="check_and_submit(this.form)">
							<option value=""> - Select saved report - </option>
							<?php
							$sched_str = "";
							foreach ($saved_sla as $k => $info) {
								if (in_array($info['id'], $scheduled_ids)) {
									$sched_str = " ( *Scheduled* )";
									$title_str = $scheduled_periods[$info['id']]." schedule";
								} else {
									$sched_str = "";
									$title_str = "";
								}
								echo '<option title="'.$title_str.'" '.(($sla_id == $info['id']) ? 'selected="selected"' : '').' value="'.$info['id'].'">'.$info['sla_name'].$sched_str.'</option>'."\n";
							} ?>
						</select>
						<input type="submit" class="button select" value="Select" name="fetch_sla" />
						<input type="button" class="button new" value="New" name="new_sla" title="Create new SLA" id="new_sla" onclick="self.location.href='<?php echo $_SERVER['PHP_SELF'] ?>'" />
						<input type="button" class="button delete" value="Delete" name="delete_sla" title="Delete SLA" id="delete_sla" onclick="confirm_delete_sla(this.form.sla_id.value, '<?php echo $_SERVER['PHP_SELF'] ?>', '<?php echo $is_scheduled ? 'true' : 0 ?>');" />
			<?php
			if ($is_scheduled) {
				$periods = array();
				$json_periods = false;
				$periods_res = get_available_autoreport_periods();
				foreach ($periods_res as $period_row) {
					$periods[$period_row['id']] = $period_row['periodname'];
				}
				if (!function_exists('json_encode')) {
					$json = new JSON();
					$json_periods = $json->encode($periods);
					unset($json);
				} else {
					$json_periods = json_encode($periods);
				}
				$recipients = false;
				$a = 0;?>
				<span id="autoreport_periods"><?php echo $json_periods ?></span>
				<span id="is_scheduled" title="This report has been scheduled. Click on '[edit]' to change settings">
					This is a scheduled report
					<a href="#" id="show_scheduled" class="help">[edit]</a>
				</span>
				<div id="schedule_report" style='width: 100%'>
					<table id="schedule_report_table" style='width: 100%'>
					<?php
					if (!empty($scheduled_info)) { ?>
					<thead>
						<tr id="schedule_header">
							<th style='width: 5%'>Interval</th>
							<th style='width: 20%'>Recipients</th>
							<th style='width: 20%'>Filename</th>
							<th style='width: 50%'>Description</th>
							<th style='width: 5%'></th>
						</tr>
					</thead>
					<tbody>
					<?php
						foreach ($scheduled_info as $schedule) {
							$recipients = str_replace(' ', '', $schedule['recipients']);
							$recipients = str_replace(',', ', ', $recipients);	?>
						<tr id="report-<?php echo $schedule['id'] ?>">
						<td class="period_select" title="Double click to edit" id="period_id-<?php echo $schedule['id'] ?>"><?php echo $schedule['periodname'] ?></td>
						<td class="iseditable" title="Double click to edit" id="recipients-<?php echo $schedule['id'] ?>"><?php echo $recipients ?></td>
						<td class="iseditable" title="Double click to edit" id="filename-<?php echo $schedule['id'] ?>"><?php echo $schedule['filename'] ?></td>
						<td class="iseditable_txtarea" title="Double click to edit" id="description-<?php echo $schedule['id'] ?>"><?php echo utf8_decode($schedule['description']) ?></td>
						<td class="delete_report" id="<?php echo $schedule['id'] ?>" style='text-align: right'><img src="../icons/cross_12x12.gif"></td>
					</tr>
			<?php 		}
					} ?>
					</tbody>
					</table>
				</div>
	<?php	} ?>
				</div>
				</form>
			</div>
			<?php } ?>

			<form name="sla_form" id="sla_form" method="post" action="sla.php" onsubmit="return check_form_values(this);">
				<div class="setup-table">
						<table summary="0" class="white-table" id="main_table" style="width: 100%; border-right: 1px solid #dcdccd; border-bottom: 1px solid #dcdccd; border-left: 1px solid #dcdccd">
						<colgroup>
							<col style="width: 10px" />
							<col style="width: 350px" />
							<col style="width: 20px" />
							<col style="width: 350px" />
							<col style="width: auto" />
						</colgroup>
						<tr class="setup">
								<th colspan="5">Create SLA report</th>
							</tr>
						<tr class="odd">
							<td><a href="#" onclick="help('report-type')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
							<td colspan="4">
								<select name='report_type' onchange="set_selection(this.value);">
								<option value="hostgroups">Hostgroup(s)</option>
								<option value="hosts">Host(s)</option>
								<option value="servicegroups">Servicegroup(s)</option>
								<option value="services">Service(s)</option>
								</select>
								<input type="button" id="sel_report_type" onclick="set_selection(this.form.report_type.value);" class="button select20" value="Select" />
							</td>
						</tr>
						<tr id="hostgroup_row" class="even">
							<td>&nbsp;</td>
							<td class="top">
							<?php $type = 'hostgroup'; ?>
							<strong>Available <?php echo $type ?>s</strong> &nbsp;
							<select name='<?php echo $type ?>_tmp[]' id="<?php echo $type ?>_tmp[]" multiple="multiple" size='8' class="multiple" ondblclick="moveSelectedOption(this.id, '<?php echo $type ?>[]');">
							</select>
							</td>
							<td class="move-buttons">
								<input type="button" value="&gt;" onclick="moveOptions(this.form.elements['<?php echo $type ?>_tmp[]'], this.form.elements['<?php echo $type ?>[]']);"  class="button arrow-right" /><br />
								<input type="button" value="&lt;" onclick="moveOptions(this.form.elements['<?php echo $type ?>[]'], this.form.elements['<?php echo $type ?>_tmp[]']);" class="button arrow-left" style="margin-top: 7px" />
							</td>
							<td class="top odd">
								<strong>Selected <?php echo $type ?>s</strong>
								<select name='<?php echo $type ?>[]' id="<?php echo $type ?>[]" multiple="multiple" size="8" class="multiple" ondblclick="moveSelectedOption(this.id, '<?php echo $type ?>_tmp[]');">
								</select>
							</td>
							<td>&nbsp;</td>
						</tr>
						<tr id="servicegroup_row" class="even">
							<td>&nbsp;</td>
							<td class="border-left">
								<?php $type = 'servicegroup'; ?>
							<strong>Available <?php echo $type ?>s</strong> &nbsp;
							<select name='<?php echo $type ?>_tmp[]' id="<?php echo $type ?>_tmp[]" multiple="multiple" size='8' class="multiple" ondblclick="moveSelectedOption(this.id, '<?php echo $type ?>[]');">
							</select>
							</td>
							<td class="move-buttons">
								<input type="button" value="&gt;" onclick="moveOptions(this.form.elements['<?php echo $type ?>_tmp[]'], this.form.elements['<?php echo $type ?>[]']);"  class="button arrow-right" /><br />
								<input type="button" value="&lt;" onclick="moveOptions(this.form.elements['<?php echo $type ?>[]'], this.form.elements['<?php echo $type ?>_tmp[]']);" class="button arrow-left" style="margin-top: 7px" />
							</td>
							<td class="top odd">
								<strong>Selected <?php echo $type ?>s</strong>
								<select name='<?php echo $type ?>[]' id="<?php echo $type ?>[]" multiple="multiple" size="8" class="multiple" ondblclick="moveSelectedOption(this.id, '<?php echo $type ?>_tmp[]');">
								</select>
							</td>
							<td>&nbsp;</td>
						</tr>
						<tr id="host_row_2" class="even">
							<td>&nbsp;</td>
							<td class="top">
								<strong>Available hosts</strong> &nbsp;
								<select name='host_tmp[]' id="host_tmp[]" multiple="multiple" size='8' class="multiple" ondblclick="moveSelectedOption(this.id, 'host_name[]');">
								</select>
							</td>
							<td class="move-buttons">
								<input type="button" value="&gt;" onclick="moveOptions(this.form.elements['host_name_tmp[]'], this.form.elements['host_name[]']);"  class="button arrow-right" /><br />
								<input type="button" value="&lt;" onclick="moveOptions(this.form.elements['host_name[]'], this.form.elements['host_name_tmp[]']);" class="button arrow-left" style="margin-top: 7px" />
							</td>
							<td class="top odd">
								<strong>Selected hosts</strong>
								<select name='host_name[]' id="host_name[]" multiple="multiple" size="8" class="multiple" ondblclick="moveSelectedOption(this.id, 'host_tmp[]');">
								</select>
							</td>
							<td>&nbsp;</td>
						</tr>
						<tr id="service_row_2" class="even">
							<td>&nbsp;</td>
							<td class="top border-left">
								<strong>Available services</strong> &nbsp;
								<select name='service_tmp[]' id="service_tmp[]" multiple="multiple" size='8' class="multiple" ondblclick="moveSelectedOption(this.id, 'service_description[]');">
								</select>
							</td>
							<td class="move-buttons">
								<input type="button" value="&gt;" onclick="moveOptions(this.form.elements['service_tmp[]'], this.form.elements['service_description[]']);"  class="button arrow-right" /><br />
								<input type="button" value="&lt;" onclick="moveOptions(this.form.elements['service_description[]'], this.form.elements['service_tmp[]']);" class="button arrow-left" style="margin-top: 7px" />
							</td>
							<td class="top odd">
								<strong>Selected services</strong>
								<select name='service_description[]' id="service_description[]" multiple="multiple" size="8" class="multiple" ondblclick="moveSelectedOption(this.id, 'service_tmp[]');">
								</select>
							</td>
							<td>&nbsp;</td>
						</tr>
					</table>
			</div>

			<div class="setup-table" id="settings_table">
				<table style="width: 100%;border-right: 1px solid #dcdccd" class="white-table">
					<colgroup>
						<col style="width: 10px;" />
						<col style="width: 280px" />
						<col style="width: auto" />
					</colgroup>
					<tr class="odd">
						<td><a href="#" onclick="help('reporting_period')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
						<td>Reporting period</td>
						<td>
							<? $type = 'report_period'; ?>
							<select name="<?php echo $type ?>" id="<?php echo $type ?>" onchange="show_calendar(this.value);">
								<option value="thisyear">This Year</option>
								<option value="lastyear">Last Year</option>
								<option value="lastmonth">Last month</option>
								<option value="last3months">Last 3 months</option>
								<option value="last6months">Last 6 months</option>
								<option value="lastquarter">Last Quarter</option>
								<option value="last12months">Last 12 months</option>
								<option value="custom">* CUSTOM REPORT PERIOD *</option>
							</select>
						</td>
					</tr>
					<tr id="display" style="display: none; clear: both;" class="even">
						<td colspan="2">&nbsp;</td>
						<td>
							<input type="hidden" name="start_time" id="start_time" value="" />
							<input type="hidden" name="end_time" id="end_time" value="" />
							<table summary="Reporting time" style="margin-left: -4px">
								<tr>
									<td>Start year</td>
									<td><select name="start_year" id="start_year"  style="width: 50px" onchange="js_print_date_ranges(this.value, 'start', 'month');"><option value=""></option></select></td>
									<td>Start month</td>
									<td><select name="start_month" id="start_month" style="width: 50px" onchange="check_custom_months();"><option value=""></option></select></td>
								</tr>
								<tr>
									<td>End year</td>
									<td><select name="end_year" id="end_year" style="width: 50px" onchange="js_print_date_ranges(this.value, 'end', 'month');"><option value=""></option></select></td>
									<td>End month</td>
									<td><select name="end_month" id="end_month" style="width: 50px" onchange="check_custom_months();"><option value=""></option></select></td>
								</tr>
							</table>
						</td>
					</tr>
					<tr class="even">
						<td><a href="#" onclick="help('report_time_period')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
						<td>Report time period</td>
						<td>
							<select name="rpttimeperiod">
							<option value=""></option>
								<?php get_reporting_periods(); ?>
							</select>
						</td>
					</tr>
					<tr class="odd">
						<td><a href="#" onclick="help('scheduled_downtime')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
						<td colspan="2">
							<input type="checkbox" class="checkbox" value="1" id="scheduleddowntimeasuptime" name="scheduleddowntimeasuptime"
									onchange="toggle_label_weight(this.checked, 'sched_downt')"  <?php print $scheduled_downtime_as_uptime_checked; ?>/>
							<label for="scheduleddowntimeasuptime" id="sched_downt">Count scheduled downtime as uptime</label>
						</td>
					</tr>
					<tr class="even">
									<td><a href="#" onclick="help('initial_states')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
									<td colspan="2">
										<input type="checkbox" class="checkbox" value="1" id="assumeinitialstates" name="assumeinitialstates"
												onchange="show_state_options(this.checked);toggle_label_weight(this.checked, 'assume_initial');"  <?php print $assume_initial_states_checked; ?>/>
										<label for="assumeinitialstates" id="assume_initial">Assume initial states</label>
									</td>
								</tr>
										<tr class="odd" id="assumed_host_state">
											<td><a href="#" onclick="help('first_assumed_host')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
											<td>&nbsp;&nbsp; First assumed host state</td>
											<td>
												<select style="width: 140px" name='initialassumedhoststate'>
												<?php
													foreach($initial_assumed_host_states as $host_state_value => $host_state_txt)
													{
														$sel = ($host_state_value == $initial_assumed_host_state_selected ? 'selected="selected"':'');
														print "<option value='$host_state_value' $sel>$host_state_txt</option>";
													}
												 ?>
												</select>
											</td>
										</tr>
										<tr class="even" id="assumed_service_state">
											<td><a href="#" onclick="help('first_assumed_service')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
											<td>&nbsp;&nbsp; First assumed service state</td>
											<td>
												<select style="width: 140px" name='initialassumedservicestate'>
												<?php
													foreach($initial_assumed_service_states as $service_state_value => $service_state_txt)
													{
														$sel = ($service_state_value == $initial_assumed_service_state_selected ? 'selected="selected"':'');
														print "<option value='$service_state_value' $sel>$service_state_txt</option>";
													}
												 ?>
												</select>
										</td>
									</tr>
								<tr class="odd">
									<td><a href="#" onclick="help('stated_during_downtime')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
									<td colspan="2">
										<input type="checkbox" class="checkbox" value="1" id="assumestatesduringnotrunning" name="assumestatesduringnotrunning"
												onchange="toggle_label_weight(this.checked, 'assume_progdown');" <?php print $assume_states_during_not_running_checked; ?>/>
										<label for="assumestatesduringnotrunning" id="assume_progdown">Assume states during program downtime</label>
									</td>
								</tr>
								<tr class="even">
									<td><a href="#" onclick="help('include_soft_states')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
									<td colspan="2">
										<input type="checkbox" class="checkbox" value="1" id="includesoftstates" name="includesoftstates"
												onchange="toggle_label_weight(this.checked, 'include_softstates');" <?php print $include_soft_states_checked; ?>/>
										<label for="includesoftstates" id="include_softstates">Include soft states</label>
									</td>
								</tr>
								<tr class="odd">
									<td><a href="#" onclick="help('use_average')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
									<td>
										&nbsp;&nbsp;SLA calculation method
									</td>
									<td>
										<select name='use_average'>
											<option value='0' <?php print $use_average_no_selected ?>>Group availability (SLA)</option>
											<option value='1' <?php print $use_average_yes_selected ?>>Average</option>
										</select>
									</td>
								</tr>
								<tr class="even">
									<td><a href="#" onclick="help('use_alias')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
									<td colspan="2">
										<input type="checkbox" class="checkbox" value="1" id="use_alias" name="use_alias"
												onchange="toggle_label_weight(this.checked, 'usealias');" <?php print $use_alias_checked; ?>/>
										<label for="use_alias" id="usealias">Use alias</label>
									</td>
								</tr>
								<tr class="odd">
									<td style="width: 10px"><a href="#" onclick="help('save_sla')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
									<td>
										<input type="hidden" name="saved_sla_id" value="<?php echo $sla_id ?>" />
										<input type="checkbox" class="checkbox" name="disabled_save_sla_settings" id="disabled_save_sla_settings" value="1" onclick="toggle_field_visibility(this.checked, 'sla_save_information');toggle_label_weight(this.checked, 'save_sla_label')" />
										<label for="save_sla_settings" id="save_sla_label">Save SLA</label>
									</td>
									<td>
										<span id="sla_save_information">
											This functionality is no longer available in the old GUI.<br />
											Please use the <a href="/monitor" target="_blank">new GUI</a> to schedule your reports.
										</span>
									</td>
								</tr>
							</table>
			</div>

			<div class="setup-table" id="enter_sla">
					<table class="white-table" style="width:100%; margin-top: 10px; border-right: 1px solid #dcdccd">
						<tr class="setup">
							<th colspan="14">Enter SLA</th>
						</tr>

						<tr class="odd">
							<td style="width: 10px"><a href="#" onclick="help('enter-sla')" class="help"><img src="../icons/shield-help_14x14.png" alt="Help" title="Help" /></a></td>
							<?php foreach ($months as $key => $month) { ?>
							<td style="width: 54px">
								<img src="../icons/16x16/copy.png" id="month_<?php echo ($key+1) ?>" alt="Click to propagate this value to all months" title="Click to propagate this value to all months" onclick="handle_autofill(this.id);" style="cursor: pointer; margin-bottom: -4px" />
								<?php echo $month ?><br />
								<input type="text" size="2" style="width: 35px" name="month_<?php echo ($key+1) ?>" value="<?php echo get_array_var($sla_info, 'month_'.($key + 1))!==false ? $sla_info['month_'.($key + 1)] : "" ?>" maxlength="6" /> % &nbsp;
							</td>
							<?php	} ?>
							<td style="width: auto">&nbsp;</td>
						</tr>

					</table>
		</div>

		<div class="setup-table" id="sla_setup">
			<input id="submit_button" type="submit" name="" value="Create report" class="button create-report" onclick="loopElements(this.form);" style="margin-top: 7px" />
		</div>

		</form>

		<script type="text/javascript">
		<!--
			var invalid_sla_info_names = <?php echo $old_config_names_js ?>;
			if (document.forms['sla_form']) {
				<?php if ($sla_info) {
						// Populate fields from saved config
						if (!function_exists('json_encode')) {
							$json = new JSON();
							$json_val = $json->encode($sla_info);
						} else {
							$json_val = json_encode($sla_info);
						}?>
					expand_and_populate(<?php echo $json_val ?>);<?php } ?>
					uncheck('disabled_save_sla_settings', 'sla_form');
			}
			$("#sla_save_information").hide();

			js_print_date_ranges();

			<?php if (!$sla_info) { ?>
			set_selection(document.getElementsByName('report_type').item(0).value);
			<?php } ?>

			<?php if($assume_initial_states_checked) { ?>
				show_state_options(true);
				toggle_label_weight(true, 'assume_initial');
			<?php } if($scheduled_downtime_as_uptime_checked) { ?>
				toggle_label_weight(true, 'sched_downt');
			<?php } if($include_soft_states_checked) { ?>
				toggle_label_weight(true, 'include_softstates');
			<?php } if($assume_states_during_not_running_checked) { ?>
				toggle_label_weight(true, 'assume_progdown');
			<?php } ?>

			disable_sla_fields(document.getElementById("<?php echo $type ?>").value);
			var nr_of_scheduled_instances = <?php echo !empty($scheduled_info) ? sizeof($scheduled_info) : 0; ?>;
		//-->
		</script>
		<div id="progress"></div>
	</body>
</html>
