<?php
require_once(dirname(__FILE__).'/lib_sla.php');
global $op5common_path;
require_once($op5common_path.'/lib/xajax/xajax_plugins/response/ajax_scriptaculous.php');
require_once($op5common_path."/lib/json_class.php");

require_once '../lib_pdf.php';
require_once('../template_class.php');

if (!get_array_var($_REQUEST, 'report_type')) {
	header('location:index.php');
	exit;
}

$map_type_field = array(
	'hosts' => "host_name",
	'services' => "service_description",
	'hostgroups' => "hostgroup",
	'servicegroups' => "servicegroup"
);

$setup_keys = array(
	'sla_name',
	'info',
	'rpttimeperiod',
	'report_period',
	'start_time',
	'end_time',
	'report_type',
	'initialassumedhoststate',
	'initialassumedservicestate',
	'assumeinitialstates',
	'scheduleddowntimeasuptime',
	'assumestatesduringnotrunning',
	'includesoftstates',
	'use_average',
	'use_alias',
    'keep_logs',
	'keep_logs_maxrows',
);

$sla_field_names = array(
	'hosts' => 'PERCENT_TOTAL_TIME_UP',
	'hostgroups' => 'PERCENT_TOTAL_TIME_UP',
	'services' => 'PERCENT_TOTAL_TIME_OK',
	'servicegroups' => 'PERCENT_TOTAL_TIME_OK'
);

# Duplicated in lib_sla.php to get pdf generation to access it
$options = array(
	'rpttimeperiod' => 'report_timeperiod',
	'scheduleddowntimeasuptime' => 'scheduled_downtime_as_uptime',
	'assumestatesduringnotrunning' => 'assume_states_during_not_running',
	'includesoftstates' => 'include_soft_states',
	'assumeinitialstates' => 'assume_initial_states',
	'keep_logs' => 'keep_logs',
	'keep_logs_maxrows' => 'keep_logs_maxrows',
	'keep_logs_states' => 'keep_logs_states'
);
# Duplicated in lib_sla.php to get pdf generation to access it
$dep_vars = array(
	'assumeinitialstates' => array(
		'initialassumedhoststate' => 'initial_assumed_host_state',
		'initialassumedservicestate' => 'initial_assumed_service_state'
	)
);

$months = array(
	'Jan',
	'Feb',
	'Mar',
	'Apr',
	'May',
	'Jun',
	'Jul',
	'Aug',
	'Sep',
	'Oct',
	'Nov',
	'Dec'
);

$err_msg = false;

$in_months = get_month_values($_REQUEST);
$sla_options = false;

#global $setup_keys;
foreach ($setup_keys as $k)	$sla_options[$k] = false;

// store all variables in array for later use
foreach ($_REQUEST as $key => $value) {
	if (in_array($key, $setup_keys)) {
		if (get_array_var($_REQUEST, 'report_period') == 'custom' && ($key=='start_time' || $key=='end_time')) {
			if(is_numeric($value))
			{
				$sla_options[$key] = $value;
				$_REQUEST[$key] = date("Y-m-d H:i", $value);
			}
			else
			{
				$sla_options[$key] = strtotime($value);
				$_REQUEST[$key] = $value;
			}
		} else {
			$sla_options[$key] = $value;
		}
	} else if ($key == 'keep_logs_states') {
		$sla_options['keep_logs_states_mask'] = states_to_mask($_REQUEST[$key]);
	}
}

$obj_field = $sla_options['report_type'] !== false ? $map_type_field[$sla_options['report_type']] : false;
$obj_value = get_array_var($_REQUEST, $obj_field);
// obj_value is ALWAYS an array

$save_sla_settings 	= get_array_var($_REQUEST, 'save_sla_settings');
$sla_id 			= get_array_var($_REQUEST, 'saved_sla_id');

$report_period = get_array_var($_REQUEST, 'report_period');
$rpttimeperiod = get_array_var($_REQUEST, 'rpttimeperiod');
$start_time    = get_array_var($_REQUEST, 'start_time');
$end_time      = get_array_var($_REQUEST, 'end_time');
$use_alias = get_array_var($_REQUEST, 'use_alias');


// convert report period to timestamps
if ($report_period=='custom' && !empty($syear) && !empty($eyear)) {
	// cgi compatibility
	$time_parts[0] = mktime($shour, $smin, $ssec, $smon, $sday, $syear);
	$time_parts[1] = mktime($ehour, $emin, $esec, $emon, $eday, $eyear);
} elseif(!empty($report_period)) {
	$time_parts = calculate_time($report_period, $start_time, $end_time);
} else {
	# Use time from t1 and t2 - when called from trends.cgi
	$time_parts = array($start_time, $end_time);
}

$str_start_date = date('Y-m-d H:i', $time_parts[0]); // used to set calendar
$str_end_date 	= date('Y-m-d H:i', $time_parts[1]); // used to set calendar

$report_period_strings = array
(
	'thisyear' => 'This year',
	'lastyear' => 'Last year',
	'lastmonth' => 'Last month',
	'last12months' => 'Last 12 months',
	'last3months' => 'Last 3 months',
	'last6months' => 'Last 6 months',
	'lastquarter' => 'Last Quarter'
);
if('custom' == $report_period)
	$report_time_formatted  = "$start_time to $end_time";
else
	$report_time_formatted  = $report_period_strings[$report_period];

if($rpttimeperiod != '')
	$report_time_formatted .= " - $rpttimeperiod";

$status_msg = '';
// Only save SLA settings if user selected this
if ($save_sla_settings) {
	$ok = edit_sla_info($sla_id, $sla_options, $in_months, $obj_value);
	$sla_id = !empty($sla_id) ? $sla_id : $ok;
	$status_msg = $sla_id ? "Report was successfully saved" : "";
}

switch($sla_options['report_type'])
{
	case 'hosts':
		/* fall through */
	case 'hostgroups':
		$object_varname = 'host_name';
		break;

	case 'services':
		/* fall through */
	case 'servicegroups':
		$object_varname = 'service_description';
		break;
}
$report_data = array();
$table_data = false;
$data = false;
$log_data = false;
// display report using submitted values (or fr db)
$sla_data = get_sla_data($sla_options, $in_months, $obj_value);
$sla_fail = 0;
$sla_ok = 0;
$sourcename = false;
# FIXME: MOVE ALL THIS LOGIC TO BACKEND
if (preg_match('/groups$/', trim($sla_options['report_type']))) {
	// loop over every group
	foreach ($sla_data as $source => $period_data) {
		unset($data);
		unset($table_data);
		unset($log_data);
		$members = null;
		$sourcename = get_sla_group_name($period_data);

		// loop over whole period for current group
		foreach ($period_data as $key => $tmp_data) {
			// 'jan' => array(99.8, 99.6), (real, sla)
			$months_key = ($key - 1);
			if (array_key_exists($key, $in_months)) {
				if (get_array_var($tmp_data, 'states')) {

					# eg: $tmp_data['states']['PERCENT_TOTAL_TIME_UP']
					$real_val = $tmp_data['states'][$sla_field_names[$sla_options['report_type']]];

					# eg: $data['Jan'] = array(99.99999, 99.5)
					$data[$months[$months_key]] = array($real_val, $in_months[$key]);

					# eg: $table_data['groupnameX']['Jan'] = array(98,342342, 98)
					$table_data[$sourcename][$months[$months_key]][] = array($real_val, $in_months[$key]);

					# log
					#var_dump($tmp_data);
					#var_dump(array_keys($tmp_data));
					$log_data[$months[$months_key]] = array('log' => $tmp_data['log'], 'log_maxrows' => $tmp_data['log_maxrows']);
				} else {
					// create empty 'real' values
					$data[$months[$months_key]] = array(0, $in_months[$key]);
					$table_data[$sourcename][$months[$months_key]][] = array(0, $in_months[$key]);
					$log_data[$months[$months_key]] = null;
				}
			}

			if(is_null($members) && get_array_var($tmp_data, 'states'))
			{
				if(isset($tmp_data['states']['SERVICE_DESCRIPTION']))
					$members = $tmp_data['states']['SERVICE_DESCRIPTION'];
				else
					$members = $tmp_data['states']['HOST_NAME'];
			}
		}

		$data_str = base64_encode(serialize($data));

		$member_links = array();
		foreach($members as $member)
		{
			$member_links[] = generate_sla_member_link($member, $object_varname, $sla_options, $in_months);
		}

		#var_dump($period_data['log']);
		#var_dump($period_data);
		$report_data[] =
			array(
				'data' => $data,
				'table_data' => $table_data,
				'data_str' => $data_str,
				'source' => $sourcename,
				'group_title'=>$sourcename,
				'member_links' => $member_links,
				'avail_links' => generate_avail_member_link($members, $object_varname, $sla_options),
				'log_header_name' => $sourcename,
				'log' => $log_data,
			);
	}
} else {
	foreach ($sla_data as $months_key => $period_data) {
		$sourcename = get_sla_group_name($period_data);
		if (array_key_exists($months_key, $in_months)) {
			if (get_array_var($period_data, 'states')) {
				$real_val = $period_data['states'][$sla_field_names[$sla_options['report_type']]];
				$data[$months[$months_key-1]] = array($real_val, $in_months[$months_key]);
				$table_data[$sourcename][$months[$months_key-1]][] = array($real_val, $in_months[$months_key]);

				$log_data[$months[$months_key-1]] = array('log' => $period_data['log'], 'log_maxrows' => $period_data['log_maxrows']);
			} else {
				$data[$months[$months_key]] = array(0, $in_months[$months_key]);
				$table_data[$sourcename][$months[$months_key]][] = array(0, $in_months[$months_key]);
				$log_data[$months[$months_key]] = null;
			}
		}
	}
	$data_str = base64_encode(serialize($data));
	$member_links = array();
	$avail_links = false;
	if(strpos($sourcename, ',') !== false)
	{
		$members = explode(',', $sourcename);
		foreach($members as $member)
		{
			$member_links[] = generate_sla_member_link($member, $object_varname, $sla_options, $in_months);
		}
		$avail_links = generate_avail_member_link($members, $object_varname, $sla_options);
	} else {
		$avail_links = generate_avail_member_link($sourcename, $object_varname, $sla_options);
	}

	$report_data = array(array
	(
		'source'=>$sourcename,
		'data_str' => $data_str,
		'table_data'=>$table_data,
		'group_title'=>false,
		'member_links'=>$member_links,
		'avail_links' => $avail_links,
	    'log_header_name' => $sourcename,
	    'log' => $log_data,
	));
}

if(!isset($_REQUEST['generating_pdf']))
	$pdf_link = get_pdf_link('sla');
else
	$pdf_link = '';

$tpl = new Template('../templates/sla_report.tpl.php');
$tpl->assign('title', 'SLA Report');
$tpl->assign('sla_id', $sla_id);
$tpl->assign('sla_options', $sla_options);
$tpl->assign('in_months', $in_months);
$tpl->assign('status_msg', $status_msg);
$tpl->assign('obj_value', $obj_value);
$tpl->assign('map_type_field', $map_type_field);
$tpl->assign('pdf_link', $pdf_link);
$tpl->assign('report_time_formatted', $report_time_formatted);
$tpl->assign('str_start_date', $str_start_date);
$tpl->assign('str_end_date', $str_end_date);


# CHANGE THESE TO REBRAND
$tpl->assign('generated_by_txt', 'Generated by');
$tpl->assign('logo_src', '../company_logo.gif');
$tpl->assign('logo_alt', 'op5 Monitor');


$scheduled_info = $sla_id ? report_is_scheduled($sla_id, 'sla') : false;
$tpl->assign('scheduled_info', $scheduled_info);
$periods_res = get_available_autoreport_periods();
$tpl->assign('periods_res', $periods_res);

$tpl_graph = new Template('../templates/sla_graph.tpl.php');
$tpl_table = new Template('../templates/sla_table.tpl.php');
$tpl_members = new Template('../templates/sla_members.tpl.php');
$tpl_log = new Template('../templates/sla_log.tpl.php');

$tpl_graph->assign('report_time_formatted', $report_time_formatted);
$tpl_graph->assign('use_alias', $use_alias);

$tpl_table->assign('report_time_formatted', $report_time_formatted);
$tpl_table->assign('use_alias', $use_alias);

$tpl_members->assign('report_time_formatted', $report_time_formatted);

$tpl_log_type = '';
if (strpos($sla_options['report_type'], 'host') === 0)
	$tpl_log_type = 'host';
else
	$tpl_log_type = 'service';

$tpl_log->assign('type', $tpl_log_type);

$content = '';
$nr = 0;
$last_report_num = count($report_data) - 1;
foreach($report_data as $i =>  $report)
{
	 if($i != $last_report_num)
		$pb = 'page-break-after: always;';
	 else
		$pb = '';

	$tpl_graph->assign('data_str', $report['data_str']);
	$tpl_graph->assign('avail_links', $report['avail_links']);
	$tpl_graph->assign('group_title', $report['group_title']);
	$tpl_graph->assign('source', $report['source']);
	$tpl_graph->assign('nr', $nr);
	$nr++;

	$tpl_table->assign('table_data', $report['table_data']);
	$tpl_table->assign('str_source', $report['source']);
	$tpl_table->assign('group_title', $report['group_title']);
	$tpl_table->assign('nr', $nr);
	$nr++;

	$tpl_members->assign('member_links', $report['member_links']);
	$tpl_members->assign('group_title', $report['group_title']);
	$tpl_members->assign('nr', $nr);
	$nr++;

	#var_dump($report);
	$tpl_log->assign('log_arr', $report['log']);
	$tpl_log->assign('nr', $nr);
	$tpl_log->assign('name', $report['log_header_name']);
	$nr++;

	$content .= "<div class='page_top_margin'></div>";
	//$content .= '<div id="general_help"></div>';

	$content .= "<div class='bottom' style='$pb'>";

	$content .= $tpl_graph->fetch();
	$content .= $tpl_table->fetch();
	$content .= $tpl_members->fetch();
	$content .= $tpl_log->fetch();


	$content .= "</div>";
}
$tpl->assign('content', $content);

echo $tpl->fetch();
?>
