<?php

# set_include_path(get_include_path().":".HTML2PS_DIR.":/opt/monitor/op5/reports/gui/sla");
$basepath = '/opt/monitor/op5/reports/gui/sla';
chdir($basepath);

require_once '/opt/monitor/op5/auto-reports/lib_auto.php';
require_once '/opt/monitor/op5/auto-reports/lib_mail.php';
require_once '../lib_reports.php';

global $dba;


if($argc < 3)
{
	error_log(sprintf("usage: %s id recipient1,recipient2,...,recipientN", $argv[0]));
	exit;
}

$id = $argv[1];
$recipients = explode(',', $argv[2]);


$query = "SELECT * FROM sla_config WHERE id = $id";
$res = $dba->execute($query);

if(count($res) > 0) /* {{{ */
{
	$row =& $res[0];

	# needed for monitor_auth
	$_SERVER['SERVER_NAME'] = 'op5monitor';
	$_SERVER['REMOTE_USER'] = $row['user'];
	$_SERVER['REQUEST_URI'] = '/monitor/op5/reports/gui/sla/sla.php';

	$baseurl = "$basepath/sla.php";
	$output_filename = '/tmp/report.pdf';
	$report_name = trim($argv[3])!='' ? $argv[3] : $row['sla_name'];

	$config_keys = array
	(
		'rpttimeperiod' ,
		'report_period' ,
		'start_time' ,
		'end_time' ,
		'report_type' ,
		'initialassumedhoststate' ,
		'initialassumedservicestate' ,
		'assumeinitialstates' ,
		'scheduleddowntimeasuptime' ,
		'assumestatesduringnotrunning' ,
		'includesoftstates' ,
	    'keep_logs',
	    'keep_logs_maxrows',
	);

	$report_inputs = array();
	foreach($config_keys as $key)
	{
		if(isset($row[$key]))
			$report_inputs[$key] = $row[$key];
		else
			$report_inputs[$key] = '';
	}

	$report_inputs['generating_pdf'] = 1;
	$report_inputs['keep_logs_states'] = mask_to_state_masks($row['keep_logs_states_mask']);

	# fetch objects
	$query = "SELECT * FROM sla_config_objects WHERE sla_id = $id";
	$res = $dba->execute($query);

	if(count($res) > 0)
	{
		$obj_key = '';
		switch($report_inputs['report_type'])
		{
			case 'hosts': 		$obj_key = 'host_name'; break;
			case 'hostgroups': 	$obj_key = 'hostgroup'; break;
			case 'services': 	$obj_key = 'service_description'; break;
			default: 			$obj_key = 'servicegroup';
		}
		$report_inputs[$obj_key] = array();

		foreach($res as $row)
			$report_inputs[$obj_key][] = $row['name'];

		# fetch periods
		$query = "SELECT * FROM sla_periods WHERE sla_id = $id";
		$res = $dba->execute($query);

		foreach($res as $row)
		{
			$month_key = $row['name'];
			if ($report_inputs['report_period'] == 'lastmonth') {
				# special case lastmonth report period to work as expected,
				# i.e to use the entered SLA value for every month
				# no matter what month it was scheduled
				$month = date('n');
				$month = $month == 1 ? 12 : ($month-1);
				$month_key = 'month_'.$month;
			}
			$report_inputs[$month_key] = $row['value'];
		}
		$output_filename = create_pdf($baseurl, $report_inputs, array('sla.php', '../chart.php'));

		send_report($recipients, $output_filename, $report_name);

		unlink($output_filename);
	}
} /* }}} */
else
{
	error_log(sprintf("%s: no SLA report with id %d", $argv[0], $id));
}

?>
