<?php
require_once (dirname( __FILE__) . '/sql_class.php');

$sql_class = new sql_class();
$db = $sql_class->db;

$test = 'multiple2';

switch ($test) {
	case 'single':
		// get a single value from the database
		if ($db->query("SELECT count(*) as tmp FROM report_data")) {
		    $count = $db->getValue(ANYDB_INT);
		    echo $count;
		} else {
		    echo $db->error;
		}
		break;
	case 'escape':
		// testing escapeStr()
		$str = "en' faslig'massa''fnutt'ar";
		echo $sql_class->escapeStr($str);
		break;
	case 'multiple':
		/**
		*	getMapped() uses one of the result columns as an index for the result set.
		*	In the example the 'host_name' column is used.
		*	If you specify only two result columns in your SQL query you will get a one
		* 	dimensional array containing the single result column instead.
		*	If you specify a column with non unique data, entries will get overwritten.
		* 	So it makes sense to use database key columns.
		*/
		if ($db->query("SELECT * FROM ".$sql_class->database.".report_data WHERE event_type=801 LIMIT 20, 20")) {
			$res = $db->getMapped('id');
			foreach ($res as $row) {
				echo $row['host_name']."<br />";
			}
		} else {
			echo $db->error;
		}
		break;
	case 'multiple2':
		// execute() combines the query() and the getAll() function.
		// It passes the query to the database and returns the complete result set.
		if ($res = $db->execute("SELECT id, host_name, timestamp, output FROM ".$sql_class->database.".report_data WHERE event_type=801 LIMIT 20, 20")) {
			foreach ($res as $row) {
				echo $row['id'] ." : ". $row['host_name'] . " - " . $row['output'] ." [".$row['timestamp']."]<br />";
			}
		} else {
			echo $db->error;
		}
		break;
	default:
		echo "Can't understand test case '".$test."'<br />";
}

?>