<?php
if (!empty($log_arr)) {
	$host_state_txt 	= array(-1 => 'PENDING', 0 => 'UP', 1 => 'DOWN', 2 => 'UNREACHABLE');
	$service_state_txt 	= array(-1 => 'PENDING', 0 => 'OK', 1 => 'WARNING', 2 => 'CRITICAL', 3 => 'UNKNOWN');

	foreach ($log_arr as $log_idx => $log_obj) {
		$source = $log_obj['source'];
		$log = $log_obj['log'];
		$log_maxrows = $log_obj['log_maxrows'];
		$id_prefix = "log_" . $log_idx . "_";
?>
	<div id="<?php echo $id_prefix;?>entries">
		<h1 id="<?php echo $id_prefix;?>-log-h1" onclick="show_hide('<?php echo $id_prefix;?>-log',this)"><?php echo ucfirst($type) ?> Log Entries for <?php echo $log_obj['name']; ?></h1>
		<div class="icon-help" onclick="general_help('log_entries')"></div>
		<fieldset id="<?php echo $id_prefix;?>-log">
			<!-- <form onsubmit="return false;" action=""><div><input type="text" size="60" name="filterbox" id="<?php echo $id_prefix;?>filterbox" value="Enter text to filter" /></div></form> -->
			<table id="<?php echo $id_prefix;?>-log-table">
				<colgroup>
					<col class="col_label" />
					<col class="col_host" />
					<?php if ($type == "service") {?>
					<col class="col_service" />
					<?php } ?>
					<col class="col_date" />
					<col class="col_date" />
					<col class="col_duration" />
					<col class="col_information" />
				</colgroup>
				<thead>
				<tr>
					<th>&nbsp;</th>
					<th>Host</th>
					<?php if ($type == "service") {?>
					<th>Service</th>
					<?php } ?>
					<th>Start time</th>
					<th>End time</th>
					<th>Duration</th>
					<th>Information</th>
				</tr>
				</thead>
				<tbody>
				<?php foreach ($log as $key => $value) {
					if (isset($value['state'])) {
					$event_end_time = $value['the_time'] + $value['duration'];
				?>
				<tr>
					<td class="label <? echo strtolower(${$type.'_state_txt'}[$value['state']]); ?>-left">
						<?php echo ucfirst(strtolower(${$type.'_state_txt'}[$value['state']])); ?>
					</td>
					<td><?php if (isset($value['host_name'])) echo $value['host_name']; ?></td>
					<?php if ($type == "service") {?>
						<td><?php if (isset($value['service_description'])) echo $value['service_description']; ?></td>
					<?php } ?>
					<td><?php echo date('Y-m-d, H:i:s', $value['the_time']); ?></td>
					<td><?php echo date('Y-m-d, H:i:s', $event_end_time); ?></td>
					<td><?php echo time_to_string($value['duration']); ?></td>
					<td class="border-right"><?php echo $value['output']; ?></td>
				</tr>
				<?php } } ?>
				</tbody>
			</table>
			<?php if (count($log) == $log_maxrows && $log_maxrows != 0) { ?>
				<span class="warning">Maximum number of rows reached, log events might be missing!</span>
			<?php } ?>
		</fieldset>
	</div>
	<script type="text/javascript">
		//document.getElementById('<?php echo $id_prefix;?>-log').style.display='none';
		//document.getElementById('<?php echo $id_prefix;?>-log-h1').style.background = 'url(images/icons/arrows/grey.gif) 11px 3px no-repeat';
	</script>
<?php } } ?>
