<?php

require_once('paths.inc.php');
global $op5common_path;
require_once($op5common_path . '/lib/common.php');
require_once('/opt/monitor/op5/gui/gui_api.inc.php');

gui_init(false);

class monitor_auth_class
{
	var $gui_db = false;
	var $id = false;
	var $user;
	var $hosts = array();
	var $hosts_r = array();
	var $services = array();
	var $services_r = array();
	var $hostgroups = array();
	var $hostgroups_r = array();
	var $servicegroups = array();
	var $servicegroups_r = array();
	var $view_hosts_root = false;
	var $view_services_root = false;
	var $command_hosts_root = false;
	var $command_services_root = false;

	function monitor_auth_class($user)
	{
		$this->user = $user;
		$this->check_rootness();
		$this->sql_connect();

		if (empty($user))
			return false;

		$this->get_contact_id();
	}

	# This is required for testing purposes.
	# The backdoor side of it can safely be ignored, since the
	# reports library has zero authentication anyway, and
	# return-into-libzend or similar exploits are impossible from php
	function i_can_has_root_plx()
	{
		$this->view_hosts_root = true;
		$this->view_services_root = true;
	}

	function check_rootness()
	{
		global $cgi_config;

		if (in_array($this->user, $cgi_config['authorized_for_all_hosts'])) {
			$this->view_hosts_root = true;
		}

		if (in_array($this->user, $cgi_config['authorized_for_all_services'])) {
			$this->view_services_root = true;
		}
		/* Allow * in cgi.cfg, which mean everybody should get 'rootness' */
		if (in_array("*", $cgi_config['authorized_for_all_hosts'])) {
			$this->view_hosts_root = true;
		}

		if (in_array("*", $cgi_config['authorized_for_all_services'])) {
			$this->view_services_root = true;
		}

	}

	function sql_connect()
	{
		return gui_db_connect();
	}

	function get_contact_id()
	{
		if ($this->view_hosts_root && $this->view_services_root)
			return true;

		$query = 'SELECT id FROM contact WHERE contact_name = \'' .
			mysql_escape_string($this->user) . "'";

		$result = sql_exec_query($query);
		$row = sql_fetch_row($result);
		if (!$row) {
			$this->id = false;
			return false;
		}
		$this->id = $row[0];

		return $this->id;
	}

	function get_authorized_hosts()
	{
		if (!empty($this->hosts))
			return $this->hosts;

		$query =
			'SELECT DISTINCT host.id, host.host_name from host, ' .
			'contact_contactgroup, contact, host_contactgroup ' .
			'WHERE host.id = host_contactgroup.host ' .
			'AND host_contactgroup.contactgroup = contact_contactgroup.contactgroup ' .
			'AND contact_contactgroup.contact = "' . $this->id.'"';

		if ($this->view_hosts_root)
			$query = 'SELECT id, host_name from host';

		$result = sql_exec_query($query);
		while ($ary = sql_fetch_array($result)) {
			$id = $ary['id'];
			$name = $ary['host_name'];
			$this->hosts[$id] = $name;
			$this->hosts_r[$name] = $id;
		}

		return $this->hosts;
	}

	function get_authorized_services()
	{
		if (!empty($this->services))
			return $this->services;

		$query =
			'SELECT DISTINCT service.id, host.host_name, service.service_description ' .
			'FROM host, service, contact, contact_contactgroup, service_contactgroup ' .
			'WHERE service.id = service_contactgroup.service ' .
			'AND service_contactgroup.contactgroup = contact_contactgroup.contactgroup ' .
			'AND contact_contactgroup.contact = ' . $this->id . ' AND';

		if ($this->view_services_root) {
			$query = 'SELECT DISTINCT service.id, host.host_name, service.service_description ' .
				'FROM host, service WHERE';
		}

		$query .= ' host.id = service.host_name';

		$result = sql_exec_query($query);
		$front = $back = array();
		while ($ary = sql_fetch_array($result)) {
			$id = $ary['id'];
			$name = $ary['host_name'] . ';' . $ary['service_description'];
			$this->services[$id] = $name;
			$this->services_r[$name] = $id;
		}

		return $this->services;
	}

	function get_authorized_hostgroups()
	{
		if (!empty($this->hostgroups))
			return $this->hostgroups;

		if (empty($this->hosts))
			$this->get_authorized_hosts();

		$query = 'SELECT id, hostgroup_name FROM hostgroup';
		$result = sql_exec_query($query);
		while ($ary = sql_fetch_array($result)) {
			$id = $ary['id'];
			$name = $ary['hostgroup_name'];
			$query = "SELECT host FROM host_hostgroup WHERE hostgroup = $id";
			$res = sql_exec_query($query);
			$ok = true;
			while (!$this->view_hosts_root && $ok && $row = sql_fetch_row($res)) {
				error_log('doing while loop');
				if (!isset($this->hosts[$row[0]])) {
					$ok = false;
					break;
				}
			}

			if ($ok) {
				$this->hostgroups[$id] = $name;
				$this->hostgroups_r[$name] = $id;
			}
		}

		return $this->hostgroups;
	}

	function get_authorized_servicegroups()
	{
		if (!empty($this->servicegroups))
			return $this->servicegroups;

		if (empty($this->services))
			$this->get_authorized_services();

		$query = 'SELECT id, servicegroup_name FROM servicegroup';
		$result = sql_exec_query($query);
		while ($ary = sql_fetch_array($result)) {
			$id = $ary['id'];
			$name = $ary['servicegroup_name'];
			$query = "SELECT service FROM service_servicegroup WHERE servicegroup = $id";
			$res = sql_exec_query($query);
			$ok = true;
			while (!$this->view_services_root && $ok && $row = sql_fetch_row($res)) {
				if (!isset($this->services[$row[0]])) {
					$ok = false;
					break;
				}
			}

			if ($ok) {
				$this->servicegroups[$id] = $name;
				$this->servicegroups_r[$name] = $id;
			}
		}

		return $this->servicegroups;
	}

	function is_authorized_for_host($host)
	{
		if ($this->view_hosts_root === true)
			return true;

		if (!$this->hosts)
			$this->get_authorized_hosts();

		if (is_numeric($host)) {
			if (isset($this->hosts[$host]))
				return true;
		}
		if (isset($this->hosts_r[$host]))
			return true;

		return false;
	}

	function is_authorized_for_service($service)
	{
		if ($this->view_services_root === true)
			return true;

		if (!$this->services)
			$this->get_authorized_services();

		if (is_numeric($service)) {
			if (isset($this->services[$service]))
				return true;
		}
		if (isset($this->services_r[$service]))
			return true;

		return false;
	}

	function is_authorized_for_hostgroup($hostgroup)
	{
		if ($this->view_hosts_root === true)
			return true;

		if (!$this->hostgroups)
			$this->get_authorized_hostgroups();

		if (is_numeric($hostgroup)) {
			if (isset($this->hostgroups[$hostgroup]))
				return true;
		}
		if (isset($this->hostgroups_r[$hostgroup]))
			return true;

		return false;
	}

	function is_authorized_for_servicegroup($servicegroup)
	{
		if ($this->view_services_root === true)
			return true;

		if (!$this->servicegroups)
			$this->get_authorized_servicegroups();

		if (is_numeric($servicegroup)) {
			if (isset($this->servicegroups[$servicegroup]))
				return true;
		}
		if (isset($this->servicegroups_r[$servicegroup]))
			return true;

		return false;
	}
}

?>
